/**
 * Handle spécifique à chaque agent instancié
 */
package skuad.agentu;

import skuad.uda.*;
import skuad.ubiquity.space.*;
import skuad.util.time.Pulse;
import skuad.util.value.Value;

public interface AgentUDescriptor {	
	
	public int id();
	public String getName();	//retourne le nom affecté à l'agent
	public String typeAgent();
	public long curTime();		//lecture du temps courant
	public int state();			//lecture de l'état courant de l'agent
	public int runMode();		//lecture du mode d'exécution de l'agent	
	//[RUN_AGENT / STOP_AGENT / PAUSE_AGENT](int : request_id)[agent_id]		-> action : run/stop/pause sur un agent (si request_id!=0 alors une réponse est attendu)
	
	public void log(String mess);	//message de log
	
	//Rythme du comportement
	public Pulse pulse(String label, long delay,  boolean fire_uptodate); //pulse ponctuel
	public Pulse loopPulse(String label, long delay,  long periode, boolean reset_on_resume); //pulse périodique
			//si periode<=0 l'appel sera équivalent à  pulse(label, delay, reset_on_resume)	
	
	public Value getConfig(); //lecture de la configuration de l'agent, retourne null si aucune configuration n'a été exprimé pour cet agent
	
	//Gestion des avatars d'interaction social de l'agent
	public Avatar getAvatar(String slot_name); //null si l'avatar n'est pas instancié
	public String socialSlot(Avatar a);
	public boolean isSocialPlugged(String slot_name);
	public Iterable<SocialSpecif> socialsSpecif();
	
	//Gestion des devices d'interaction physique de l'agent
	public Device getDevice(String slot_name);
	public void readSensor(String query_label, SensorTarget[] targets);
	
	public String physicalSlot(Device d);
	public boolean isPhysicalPlugged(String slot_name);
	public Iterable<PhysicalSpecif> physicalsSpecif();
	public boolean isReady(String slot);
	public int trueType(String slot);
}