/**
 * Classe de facilitation d'implémentation d'un agent (toutes les méthodes AgentU sont vide)
 */
package skuad.agentu;

import skuad.hubudp.*;

public interface AgentUObserver {
	
	public void agentTypeAdded(String name_type, int code_type);
	public void agentTypeSourceChanged(int code_type);
	
	public void agentCreated(int code_type, int agentId);
	public void agentRemoved(int agentId);
	public void agentStateChange(int agentId, byte old_state, byte new_state, byte ctx);
	public void agentRunModeChange(int agentId, byte old_run_mode, byte new_run_mode);
	
	public void agentRenamed(int agentId, String newName);
	public void agentRetypep(int agentId, int code_type);
	public void agentWaitRetype(int agentId, int code_type);
	public void agentLog(int agentId, String mess, long time);
	
	public void socialChange(int agentId, String name_slot, String name_space, String md5_space_password, String local_id); //name_space==null si plug supprimé, md5_space_password==null si aucun mot de passe, local_id==null si déterminer aléatoirement
	public void socialPlug(int agentId, String name_slot, String current_id, int ctx);
	public void socialUnplug(int agentId, String name_slot, int ctx);	
	
	public void physicalPlug(int agentId, String name_slot, Spot device_spot, int device_id);
	public void physicalChange(int agentId, String name_slot, Spot device_Spot, int device_id);
	public void physicalPlugRuleAdded(int agentId, String name_slot, int rule_id, int order, PhysicalPlugRule rule);
	public void physicalPlugRuleRemoved(int agentId, String name_slot, int rule_id);
	public void physicalPlugRuleMoved(int agentId, String name_slot, int rule_id, byte direction); //direction = PlugRule.UP ou plugRule.DOWN
	public void physicalUnplug(int agentId, String name_slot);	
}