/** v0.23
	Classe noyau de la librairie agentu
		-> elle gére le service réseau du protocole AGENTU
--------------
Limitation :
	-> 250 types d'agents possible sur un noeud
	-> 100 plug-rule maximum sur le slot d'un agent 	
	
	==> sur un hote, plusieurs serveur AgentU peuvent être présent
	
	
Légende :
	[exist]	--> ==0 si non exitence, ==1 si l'élément existe
--------------
Protocole AGENTU :

	[LIST_SERVER]			-> demande la liste de serveur AgentU porté par ce noeud (seul les serveur persistant sont visible)
	[SERVER_LIST](int: nb_server)...|pour chaque serveur: (int: code_serveur)(String : server_name)[nb_type][nb_agent]|...

	[LIST_TYPE_AGENT](int: code_serveur)	-> demande de la liste des types d'agents disponibles sur l'hote receveur
	[TYPE_AGENT_LIST](int: code_serveur)[exist][nb_type]...|pour chaque type: [code_type1](string: name1)[editable][error]{si error==true: (s: message_erreur)}|... 		

	[LIST_PHYSICAL_SLOT_SPECIF](int: code_serveur)[code_type]	-> demande de la liste des spécifications physiques du type d'agent indiqué
	[PHYSICAL_SLOT_SPECIF_LIST](int: code_serveur)[code_type][bool: exist](int: nb_slot)...|pour chaque slot: (string: name)(int: device_type)[bool: optional]|...

	[LIST_SOCIAL_SLOT_SPECIF](int: code_serveur)[code_type]	-> demande de la liste des spécifications sociales du type d'agent indiqué
	[SOCIAL_SLOT_SPECIF_LIST](int: code_serveur)[code_type][bool: exist](int: nb_slot)...|pour chaque slot: (string: name)(string: space_name)(string: local_id)|...		

	[LIST_AGENT](int: code_serveur) 	-> demande de la liste des agents porté par l'hote receveur
	[AGENT_LIST](int: code_serveur)[exist](int: nb_agent)...|pour chaque agent: (int: agent_id)[code_type_agent][code_retype](string: agent_name)[state][run_mode]|		

	[CREATE_AGENT](int : request_id)(int: code_serveur) [code_type](string: agent_name)		-> demande la création d'un nouvel agent sur l'hote receveur (si request_id!=0 alors une réponse est attendue)
	[AGENT_CREATE](int : request_id)(int: code_serveur) [bool: success](int: agent_id1)[code_type_agent](string: agent_name) 	-> réponse à une demande CREATE_AGENT

	[REMOVE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)			-> demande la suppression de l'agent sur l'hote receveur (si request_id!=0 alors une réponse est attendue)
	[AGENT_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id) 	-> réponse à une demande REMOVE_AGENT

	[RENAME_AGENT](int : request_id)(int: code_serveur)(int: agent_id)(s: name) -> demande de renommage d'un agent (si request_id!=0 alors une réponse est attendue)
	[AGENT_RENAMED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(s: name) 	-> réponse à une demande RENAME_AGENT

	[RETYPE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)[code_type] -> demande de retyper un agent 
	[AGENT_WAIT_RETYPE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type]
	[AGENT_RETYPED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type]
	 
	[ADD_OBSERVER](int: code_serveur)(int: agent_id)    --> l'hote émetteur s'inscrit comme écouteur sur l'agent indiqué, sur tous les agents si agent_id==0
	[REMOVE_OBSERVER](int: code_serveur)(int: agent_id) --> supprime l'écoute de l'hote émetteur sur l'agent indiqué (tous les agents si agent_id==0)
		
	[ADD_TYPE_AGENT](int : request_id)(int: code_serveur)(string: name)		
	[TYPE_AGENT_ADDED](int : request_id)(int: code_serveur)[bool: success][code_type](string: name)[editable][error]{si error==true: (s: message_erreur)}
				
	--> les observers recoivent les messages suivant avec request_id==0 et success=1 :
			[TYPE_AGENT_ADDED](int : request_id)(int: code_serveur)[bool: success][code_type](string: name)[editable][error]{si error==true: (s: message_erreur)}
			[AGENT_CREATE](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)[code_type_agent1](string: agent_name)
			[AGENT_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)
			[AGENT_RENAMED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(s: name)
			[AGENT_WAIT_RETYPE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type]
			[AGENT_RETYPED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type]
			 	   
			[AGENT_STATE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[state]
			[AGENT_RUN_MODE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[run_mode]
			[SOCIAL_PLUG_CHANGE](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)(string: space_name)[bool: is_private](string: local_id)
			[SOCIAL_PLUG](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)(string: current_id)[ctx]
			[SOCIAL_UNPLUG](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)[ctx]

			[PHYSICAL_PLUG](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)[bool: optional](string: owner_globalId)(int: device_id)
			[PHYSICAL_PLUG_CHANGE](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)[bool: optional](string: spot_owner_globalId)(int: device_id)
			[PHYSICAL_UNPLUG](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)[bool: optional]

			[PLUG_RULE_ADDED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}
			[PLUG_RULE_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id]

			[PLUG_RULE_MOVED](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id][direction]

			[AGENT_LOG](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(s: log)(doubleWord: time)


	[RUN_AGENT / STOP_AGENT / PAUSE_AGENT](int : request_id)(int: code_serveur)(int : agent_id)		-> action : run/stop/pause sur un agent (si request_id!=0 alors une réponse est attendu)
	[AGENT_RUN / AGENT_STOP / AGENT_PAUSE](int : request_id)(int: code_serveur)[bool: success](int : agent_id)

	[STATE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)	-> demande l'état de l'agent
	[AGENT_STATE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[state] -> réponse à une demande STATE_AGENT , state = NOT_EXIST / OFF / RUN / PAUSE / ERROR

	[CHANGE_RUN_MODE](int : request_id)(int: code_serveur)(int: agent_id)[run_mode]
	[AGENT_RUN_MODE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[run_mode]

	[LIST_SOCIAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)	-> demande de la liste des slots sociales d'un agent
	[SOCIAL_PLUG_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_slot)...|pour chaque slot: (string: name)(string: space_name)[bool: is_private](string: local_id)(string: current_id)|...		

	[LIST_PHYSICAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)	-> demande de la liste des slots sociales d'un agent
	[PHYSICAL_PLUG_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_slot)...|pour chaque slot: (string: name)(int: type)[bool: optional][bool: plugged]{si plugged1 : (int: true_type)(string: spot_owner_globalId)[device_id] }|...		

	[CHANGE_SOCIAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_name)(string: name_space)(string: password)(string: local_id)
	
	[LIST_PHYSICAL_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: name_slot)
	[PHYSICAL_RULE_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: name_slot)[nb_rules]...|pour chaque règle: [rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}|... 

	[ADD_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}
	[PLUG_RULE_ADDED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}

	[REMOVE_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id]	-->  (si request_id!=0 alors une réponse est attendu)
	[PLUG_RULE_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id]

	[MOVE_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id][direction]
	[PLUG_RULE_MOVED](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id][direction]
	
	[LOAD_SOURCE_TYPE](int : request_id)(int: server_code)[code_type]	-> demande de le code source du type code_type
	[SOURCE_TYPE](int : request_id)(int: server_code)[success][code_type](s: source)
	
	[SET_SOURCE_TYPE](int : request_id)(int: server_code)[code_type](s: source)	-> demande de changer le code source du type code_type
	[SOURCE_TYPE_CHANGED](int : request_id)(int: server_code)[success][code_type](s:message)	
	
	[LIST_LOGS](int : request_id)(int: code_serveur)(int: agent_id)	-> demande la liste des logs de l'agent (20 derniers maximum)
	[LOGS_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_log)...|pour chaque log: (String: mess)(doubleWord: time)|...  -> réponse à une demande LIST_LOGS
*/
package skuad.agentu.implementation;

import skuad.SKUAD;
import skuad.agentu.*;
import java.util.*;
import skuad.util.databytes.*;
import skuad.hubudp.*;
import skuad.agentu.implementation.amanager.*;
import skuad.ubiquity.Ubiquity;
import skuad.ubiquity.space.Space;
import skuad.uda.Device;
import skuad.uda.net.UdaUdp;

public class KernelSAU  implements MessageReceiver, RunAgentContext {
	
	//[Constante du protocole AGENTU
	public final static int LIST_SERVER   	= 40;
	public final static int SERVER_LIST 	= 41;
	
	public final static int LIST_TYPE_AGENT  			= 50;
	public final static int TYPE_AGENT_LIST  			= 51;
	
	public final static int LIST_PHYSICAL_SLOT_SPECIF   = 52;
	public final static int PHYSICAL_SLOT_SPECIF_LIST   = 53;
	
	public final static int LIST_SOCIAL_SLOT_SPECIF    	= 54;
	public final static int SOCIAL_SLOT_SPECIF_LIST   	= 55;
	
	public final static int LIST_AGENT  	= 56;
	public final static int AGENT_LIST		= 57;

	public final static int CREATE_AGENT	= 58;
	public final static int AGENT_CREATE	= 59;
	
	public final static int ADD_OBSERVER	= 60;
	public final static int REMOVE_OBSERVER	= 61;
	
	public final static int REMOVE_AGENT	= 62;
	public final static int AGENT_REMOVED	= 63;
	
	public final static int RUN_AGENT		= 64;
	public final static int STOP_AGENT		= 65;
	public final static int PAUSE_AGENT		= 66;
	
	
	public final static int AGENT_RUN		= 67;
	public final static int AGENT_STOP		= 68;
	public final static int AGENT_PAUSE		= 69;
	
	public final static int STATE_AGENT		= 70;
	public final static int AGENT_STATE		= 71;
	
	public final static int TYPE_AGENT_ADDED  = 72;
	
	public final static int CHANGE_RUN_MODE = 73;
	public final static int AGENT_RUN_MODE  = 74;

	public final static int LIST_SOCIAL_PLUG = 75;
	public final static int SOCIAL_PLUG_LIST = 76;

	public final static int LIST_PHYSICAL_PLUG	= 77;
	public final static int PHYSICAL_PLUG_LIST	= 78;
	
	public final static int CHANGE_SOCIAL_PLUG	= 79;
	public final static int SOCIAL_PLUG_CHANGE	= 80;
	public final static int SOCIAL_PLUG = 81;
	public final static int SOCIAL_UNPLUG = 82;
	
	public final static int PHYSICAL_PLUG = 83;
	public final static int PHYSICAL_PLUG_CHANGE = 84;
	public final static int PHYSICAL_UNPLUG = 85;
	
	public final static int LIST_PHYSICAL_RULE	= 86;
	public final static int PHYSICAL_RULE_LIST	= 87;
	
	public final static int ADD_PLUG_RULE	= 88;
	public final static int PLUG_RULE_ADDED	= 89;
	
	public final static int REMOVE_PLUG_RULE = 90;
	public final static int PLUG_RULE_REMOVED = 91;

	public final static int MOVE_PLUG_RULE	= 92;
	public final static int PLUG_RULE_MOVED	= 93;
	
	public final static int RENAME_AGENT = 94;
	public final static int AGENT_RENAMED = 95;
	
	public final static int RETYPE_AGENT = 96;
	public final static int AGENT_WAIT_RETYPE = 97;
	public final static int AGENT_RETYPED = 98;
	
	public final static int LOAD_SOURCE_TYPE = 99;
	public final static int SOURCE_TYPE = 100;
	public final static int SET_SOURCE_TYPE = 101;
	public final static int SOURCE_TYPE_CHANGED = 102;
	public final static int ADD_TYPE_AGENT = 103;	
	
	public final static int AGENT_LOG = 104;
	public final static int LIST_LOGS = 105;
	public final static int LOGS_LIST = 106;
	//]

	//[Entrée statique
	private static Map<Hub, KernelSAU> kernels = new HashMap<Hub, KernelSAU>();
	private synchronized static KernelSAU getKernel(Hub hub) {
		if(hub==null) hub = HubUdp.joinLocalHub();
		KernelSAU kernel = kernels.get(hub);
		if(kernel==null) { //instanciation du manager UdaUdp pour cet hub
			kernel = new KernelSAU(hub);
			kernels.put(hub, kernel);
		}
		return(kernel);
	}	
	protected static int register(Hub hub, RTAgentManager dbam){
		KernelSAU kernel = getKernel(hub);
		return(kernel.register(dbam));
	}
	//]
	
	//[interface RunAgentContext
	public Space getSpace(String space_name, String space_password) {
		return(Ubiquity.getSpace(hub, space_name, space_password));
	}
	public HostedDevice findDevice(PhysicalPlugRule prule){
		return(deviceDetector.findDevice(prule));
	}
	public void performRuleToAnonymousDevice(HostedDevice hdevice){ //on doit déclencher l'analyse des règles sur ce device sans nom
		synchronized(allDBAM) { for(RTAgentManager dbam : allDBAM){
			dbam.performRuleToAnonymousDevice(hdevice);
		}}
	}
	public void performRuleToNamedDevice(HostedDevice hdevice){ //on doit déclencher l'analyse des règles sur ce device sans nom
		synchronized(allDBAM) { for(RTAgentManager dbam : allDBAM){
			dbam.performRuleToNamedDevice(hdevice);
		}}
	}
	public Device linkDevice(DeviceHoster hoster, HostedDevice hdevice) {
		 return(UdaUdp.linkDevice(hoster.getSpot(), hdevice.getDeviceId()));
	}
	public boolean unlinkDevice(DeviceHoster hoster, HostedDevice hdevice, Device device) {
		 return(UdaUdp.unlinkDevice(device));
	}
	public boolean canRunAgent() { return(true); } //on peut toujours lancer l'exécution d'un agent en mode temps réel
	public long getCurrentTime() { return(System.currentTimeMillis()); }
	//]
	
	//Attribut interne
	DeviceDetector deviceDetector;
	Vector<RTAgentManager> allDBAM;	//tous les RTAgentManager existant
	int nb_pdbam=0; //nombre de serveur dbam persistant
	int next_dbam_id=1;
	int hi_servau_version=1;
	public Hub hub;

	
	private KernelSAU(Hub vhub){
		hub = vhub;
		deviceDetector = new DeviceDetector(this, hub);
		allDBAM = new Vector<RTAgentManager>();
		//On s'enregistre comme gestionnaire du protocole UDAUDP
		hub.addReceiver(SKUAD.AGENTU, "AgentU", this);
		
		//On fixe le SMD de support AgentU
		hub.whenReady((LocalSpot localSpot) -> localSpot.setInt(SKUAD.SMD_SERVER_AGENTU, hi_servau_version));
	}
	//]
	
	private int register(RTAgentManager dbam){
		int dbam_id=-1;
		dbam.kernel = this;
		synchronized(allDBAM) {
			allDBAM.add(dbam); 
			if(dbam.isPersistant()){ //c'est un serveur persistant
				dbam_id = next_dbam_id++;
				nb_pdbam++;
				
				hi_servau_version++; if(hi_servau_version>65000) hi_servau_version=1;
				//On met à jour la version de le SMD SERVER_AGENTU
//System.out.println("hi_servau_version change to "+hi_servau_version);					
				hub.whenReady((LocalSpot localspot) -> localspot.setInt(SKUAD.SMD_SERVER_AGENTU, hi_servau_version));
			}
		}
		return(dbam_id);
	}
	//]
		
	protected RTAgentManager findDBAM(int id){
		synchronized(allDBAM) { for(RTAgentManager dbam : allDBAM){
			if(dbam.dbam_id==id) return(dbam);
		}}
		return(null);
	}
	
	//[Interface ProtocoleManager	
	public void receive(Spot sender, DataReader message, int protocole){	// /!\ aprés lecture, on doit appliquer un .dispose() sur le message
		int cmd = message.readByte(); DataWriter wcmd=null;
		RTAgentManager dbam; int dbam_id; int code_type;
		int request_id, agent_id=0; boolean success=false;
		ExistingAgentU eau=null; String name_slot, name; int rule_id;
		
//		int code_type, request_id, agent_id=0;
//		byte rule_id, new_order;
//		String slot_plug; ExistingAgentU iau; boolean success;
//System.out.println("reception de cmd = "+cmd);		
		switch(cmd){
		case LIST_SERVER:	//[LIST_SERVER]		NB: demande la liste de serveur AgentU porté par ce noeud (seul les serveur persistant sont visible)
							//<--[SERVER_LIST](int: nb_server) ...|pour chaque serveur: (int: code_serveur)(String : server_name)[nb_type](int: nb_agent)|.
			
			synchronized(allDBAM) { 
				wcmd=DataBytes.writer().b(SERVER_LIST).i(nb_pdbam);
				for(RTAgentManager cur_dbam : allDBAM){ if(cur_dbam.dbam_id>0){
					wcmd.i(cur_dbam.dbam_id).s(cur_dbam.getServerName()).b(cur_dbam.nbAgentType()).i(cur_dbam.nbAgent());
				}}
			}
			sender.send(SKUAD.AGENTU, wcmd.flushReader());
			break;
		case LIST_TYPE_AGENT:	//[LIST_TYPE_AGENT](int: code_serveur)	-> demande de la liste des types d'agents disponibles sur l'hote receveur
			//<- réponse : [TYPE_AGENT_LIST](int: code_serveur)[exist][nb_type]...|pour chaque type : [code_type1](string: name1)[editable][error]{si error==true: (s: message_erreur)}|...
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			wcmd=DataBytes.writer().b(TYPE_AGENT_LIST).i(dbam_id);
			
			if(dbam==null) wcmd.b(0);
			else {
				wcmd.b(1);
				dbam.writeAllTypeAgent(wcmd);	
			}			
			sender.send(SKUAD.AGENTU, wcmd.flushReader());
			break;
			
		case LIST_PHYSICAL_SLOT_SPECIF: //[LIST_PHYSICAL_SLOT_SPECIF](int: code_serveur)[code_type]	-> demande de la liste des spécifications physiques du type d'agent indiqué
			//<- [PHYSICAL_SLOT_SPECIF_LIST](int: code_serveur)[code_type][bool: exist](int: nb_slot)...|pour chaque slot: (string: name)(int: device_type)[bool: optional]|...
			dbam_id = message.readInt();
			code_type = message.readByte();
			dbam = findDBAM(dbam_id);
			wcmd=DataBytes.writer().b(PHYSICAL_SLOT_SPECIF_LIST).i(dbam_id).b(code_type);
			
			if(dbam==null) wcmd.b(0);
			else dbam.writeAllPhysisicalSlotSpecif(code_type, wcmd);	//[bool: exist](int: nb_slot)...|pour chaque slot: (string: name)(int: device_type)[bool: optional]|...

			sender.send(SKUAD.AGENTU, wcmd.flushReader());
			break;
		case LIST_SOCIAL_SLOT_SPECIF: 	//[LIST_SOCIAL_SLOT_SPECIF][(int: code_serveur)[code_type]	-> demande de la liste des spécifications sociales du type d'agent indiqué
			//<- [SOCIAL_SLOT_SPECIF_LIST](int: code_serveur)[code_type][bool: exist](int: nb_slot)...|pour chaque slot: (string: name)(string: space_name)(string: local_id)|...	
			dbam_id = message.readInt();
			code_type = message.readByte();
			dbam = findDBAM(dbam_id);
			wcmd=DataBytes.writer().b(SOCIAL_SLOT_SPECIF_LIST).i(dbam_id).b(code_type);
			
			if(dbam==null) wcmd.b(0);
			else dbam.writeAllSocialSlotSpecif(code_type, wcmd);	//[bool: exist](int: nb_slot)...|pour chaque slot:(string: name)(string: space_name)(string: local_id)|...	

			sender.send(SKUAD.AGENTU, wcmd.flushReader());			
			break;			
		case LIST_AGENT: //[LIST_AGENT](int: code_serveur) 	-> demande de la liste des agents porté par l'hote receveur
			//<- [AGENT_LIST](int: code_serveur)[exist](int: nb_agent)...|pour chaque agent: (int: agent_id)[code_type_agent][code_retype](string: agent_name)[state][run_mode]|
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			wcmd=DataBytes.writer().b(AGENT_LIST).i(dbam_id);
			
			if(dbam==null) wcmd.b(0);
			else {
				wcmd.b(1);
				dbam.writeAllAgent(wcmd); //(int: nb_agent)...|pour chaque agent: (int: agent_id)[code_type_agent][code_retype](string: agent_name)[state][run_mode]|
			}
			sender.send(SKUAD.AGENTU, wcmd.flushReader());
			break;
		case CREATE_AGENT : //[CREATE_AGENT](int : request_id)(int: code_serveur) [code_type](string: agent_name) -> demande l'instanciation d'un nouvelle agent sur l'hote receveur (si request_id!=0 alors une réponse est attendu)
			//[AGENT_CREATE](int : request_id)(int: code_serveur) [bool: success](int: agent_id1)[code_type_agent1](string: agent_name) 	-> réponse à une demande NEW_AGENT
			request_id = message.readInt();
			dbam_id = message.readInt();
			code_type = message.readByte();
			name = message.readString();
			dbam = findDBAM(dbam_id);
			if(dbam!=null) {
				success=true;
				agent_id = dbam.newAgent(code_type, name, null); //les hosts observeurs seront informé par dbam //OXO: on doit donner la possibilité de spécifier la configuration de l'agent
			}
			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_CREATE);
				wcmd.writeInt(request_id);				
				wcmd.writeInt(dbam_id);				
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeByte(code_type);
				wcmd.writeString(name);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;		
		case ADD_OBSERVER : //[ADD_OBSERVER](int: code_serveur)(int: agent_id)    --> l'hote émetteur s'inscrit comme écouteur sur l'agent indiqué, sur tous les agents si agent_id==0
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			if(dbam!=null){
				agent_id = message.readInt();
				dbam.addAgentObserver(sender, agent_id);
			}
			break;
		case REMOVE_OBSERVER : 	//[REMOVE_OBSERVER](int: code_serveur)(int: agent_id) --> supprime l'écoute de l'hote émetteur sur l'agent indiqué (tous les agents si agent_id==0)
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			if(dbam!=null){
				agent_id = message.readInt();
				dbam.removeAgentObserver(sender, agent_id);
			}
			break;
		case REMOVE_AGENT : //[REMOVE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)			-> demande la suppression de l'agent sur l'hote receveur (si request_id!=0 alors une réponse est attendu)
			//[AGENT_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id) 	-> réponse à une demande REMOVE_AGENT
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null) success = dbam.removeAgent(agent_id); //--> les observeurs seront notifié par dbam  
			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_REMOVED);
				wcmd.writeInt(request_id);		
				wcmd.writeInt(dbam_id);								
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;
		case RENAME_AGENT : //[RENAME_AGENT](int : request_id)(int: code_serveur)(int: agent_id)(s: name) -> demande de renommage d'un agent (si request_id!=0 alors une réponse est attendue)
			//[AGENT_RENAMED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(s: name) 	-> réponse à une demande RENAME_AGENT
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			name = message.readString();
			if(dbam!=null) success = dbam.renameAgent(agent_id, name); //--> les observeurs seront notifié par dbam  
			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_RENAMED);
				wcmd.writeInt(request_id);		
				wcmd.writeInt(dbam_id);								
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;
		case LIST_LOGS : //[LIST_LOGS](int : request_id)(int: code_serveur)(int: agent_id)	-> demande la liste des logs de l'agent (20 derniers maximum)
			//[LOGS_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_log)...|pour chaque log: (String: mess)(doubleWord: time)|...  -> réponse à une demande LIST_LOGS
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);	
			success = (eau!=null);
			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(LOGS_LIST);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				if(success)	eau.writeLogs(wcmd); //(int: nb_log)...|pour chaque log: (String: mess)(doubleWord: time)|... 
				else wcmd.i(0);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());		
			}
			break;	
		case RETYPE_AGENT : //[RETYPE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)[code_type] -> demande de retyper un agent
			//[AGENT_RETYPED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type] 	-> réponse à une demande RETYPE_AGENT
			//ou [AGENT_WAIT_RETYPE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[code_type] 	-> si l'agent est RUN ou PAUSE
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null) eau = dbam.get(agent_id);
			code_type = message.readByte();
			if(dbam!=null) success = dbam.retypeAgent(agent_id, code_type); //--> les observeurs seront notifié par dbam  
			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(eau.getState()==AgentU.OFF ? AGENT_RETYPED : AGENT_WAIT_RETYPE);
				wcmd.writeInt(request_id);		
				wcmd.writeInt(dbam_id);								
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeByte(code_type);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;
		case RUN_AGENT:	//RUN_AGENT(int : request_id)(int: code_serveur)(int: agent_id)	 --> AGENT_RUN(int : request_id)[bool: success](int: agent_id)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null) eau = dbam.get(agent_id);
			success = (eau!=null && eau.run(AgentU.DISTANT_ORDER)); //eau va initier la propagation vers les observers !
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_RUN);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);	
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;			
		case STOP_AGENT:	//STOP_AGENT(int : request_id)(int: code_serveur)(int: agent_id)	 --> AGENT_STOP(int : request_id)(int: code_serveur)[bool: success](int: agent_id)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null) eau = dbam.get(agent_id);
			success = (eau!=null && eau.stop(AgentU.DISTANT_ORDER)); //iau va initier la propagation vers les observers !
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_STOP);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}
			break;	
		case PAUSE_AGENT:	//PAUSE_AGENT(int : request_id)(int: code_serveur)(int: agent_id)	 --> AGENT_PAUSE(int : request_id)(int: code_serveur)[bool: success](int: agent_id)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null) eau = dbam.get(agent_id);
			success = (eau!=null && eau.pause(AgentU.DISTANT_ORDER));			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_PAUSE);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}
			break;
		case STATE_AGENT : 	//[STATE_AGENT](int : request_id)(int: code_serveur)(int: agent_id)	-> demande l'état de l'agent
			//[AGENT_STATE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[state] -> réponse à une demande STATE_AGENT , state = NOT_EXIST / OFF / RUN / PAUSE / ERROR
			request_id = message.readInt();			
			if(request_id>0){
				dbam_id = message.readInt();
				dbam = findDBAM(dbam_id);
				agent_id = message.readInt();
				if(dbam!=null) eau = dbam.get(agent_id);
				success = (eau!=null);
				wcmd=DataBytes.writer().b(AGENT_STATE).i(request_id).i(dbam_id).b(success).i(agent_id).b(eau !=null ? eau.getState() : AgentU.NOT_EXIST);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}
			break;	
		case CHANGE_RUN_MODE:	//[CHANGE_RUN_MODE](int : request_id)(int: code_serveur)(int: agent_id)[run_mode]
			//[AGENT_RUN_MODE](int : request_id)(int: code_serveur)[bool: success](int: agent_id)[run_mode]
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);			
			int rmode = message.readByte();
			success = (eau!=null && eau.changeRunMode(rmode, AgentU.DISTANT_ORDER)); //eau va initier la propagation vers les observers !
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(AGENT_RUN_MODE);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeByte(rmode);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}			
			break;					
			
		case LIST_SOCIAL_PLUG:	//[LIST_SOCIAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)	-> demande de la liste des slots sociales d'un agent
			//[SOCIAL_PLUG_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_slot)...|pour chaque slot: (string: name)(string: space_name)[bool: is_private](string: local_id)(string: current_id)|...
			request_id = message.readInt();
			if(request_id>0){
				dbam_id = message.readInt();
				dbam = findDBAM(dbam_id);
				agent_id = message.readInt();
				if(dbam!=null)  eau = dbam.get(agent_id);	
				success = (eau!=null);
				
				wcmd=DataBytes.writer();
				wcmd.writeByte(SOCIAL_PLUG_LIST);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				if(success)	eau.writeAllSocialPlug(wcmd); //(int: nb_slot)...|pour chaque slot: (string: name)(string: space_name)[bool: is_private](string: local_id)(string: current_id)|...
				else wcmd.i(0);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}
			break;

		case LIST_PHYSICAL_PLUG:	//[LIST_PHYSICAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)	-> demande de la liste des slots sociales d'un agent
			//[PHYSICAL_PLUG_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(int: nb_slot)...|pour chaque slot: (string: name)(int: type)[bool: optional][bool: plugged]{si plugged1 : (int: true_type)(string: spot_owner_globalId)[device_id] }|...		
			request_id = message.readInt();
			if(request_id>0){
				dbam_id = message.readInt();
				dbam = findDBAM(dbam_id);
				agent_id = message.readInt();
				if(dbam!=null)  eau = dbam.get(agent_id);	
				success = (eau!=null);
//System.out.println("LIST_PHYSICAL_PLUG success = "+success+ " dbam!=null ? "+(dbam!=null)+" dbam_id = "+dbam_id+" agent_id = "+agent_id);					
				wcmd=DataBytes.writer();
				wcmd.writeByte(PHYSICAL_PLUG_LIST);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				if(success)	eau.writeAllPhysicalPlug(wcmd); //(int: nb_slot)...|pour chaque slot: (string: name)(int: type)[bool: optional][bool: plugged]{si plugged1 : (int: true_type)(string: spot_owner_globalId)[device_id] }|...
				else wcmd.i(0);				
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}
			break;
		case CHANGE_SOCIAL_PLUG: //[CHANGE_SOCIAL_PLUG](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_name)(string: name_space)(string: password)(string: local_id)
			//[SOCIAL_PLUG_CHANGE](int : request_id)(int: code_serveur)[bool: success](int: agent_id1)(string: slot_name)(string: space_name)[bool: is_private](string: local_id)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);	
			name_slot = message.readString();
			success = (eau!=null && eau.setSocialPlug(name_slot, message.readString(), message.readString(), message.readString())==AgentU.OK); //eau va initier la propagation vers les observers !
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(SOCIAL_PLUG_CHANGE);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name_slot);
				if(success) wcmd.s(eau.getSocialPlugNameSpace(name_slot)).b(eau.isSocialPlugPrivateSpace(name_slot)).s(eau.getSocialSlotConfigLocalId(name_slot));
				else  wcmd.s(null).b(false).s(null);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}		
			break;
			
		case LIST_PHYSICAL_RULE: //[LIST_PHYSICAL_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: name_slot)
			//[PHYSICAL_RULE_LIST](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: name_slot)[nb_rules]...|pour chaque règle: [rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}|... 
			request_id = message.readInt();
			if(request_id>0){
				dbam_id = message.readInt();
				dbam = findDBAM(dbam_id);
				agent_id = message.readInt();
				if(dbam!=null)  eau = dbam.get(agent_id);	
				success = (eau!=null);
				name_slot = message.readString();
				
				wcmd=DataBytes.writer();
				wcmd.writeByte(PHYSICAL_RULE_LIST);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name_slot);
//System.out.println("LIST_PHYSICAL_RULE success = "+success+ " dbam!=null ? "+(dbam!=null)+" dbam_id = "+dbam_id+" agent_id = "+agent_id);				
				if(success)	eau.writeAllPhysicalPlugRule(name_slot, wcmd); //[nb_rules]...|pour chaque règle: [rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}|...
				else wcmd.i(0);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}			
			break;
			
		case ADD_PLUG_RULE: //[ADD_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}
			//[PLUG_RULE_ADDED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id][rule_order][node_key]{si node_key!=ALL: (string: node_value) }[host_key]{si host_key==NAME: (string: host_value) | si  host_key==PORT: {short: port_value}}[device_key]{si device_key==NAME: (string: device_value) | si  device_key==TYPE ou ID: (int: device_value)}
//System.out.println("réception de ADD_PLUG_RULE");
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);	
			name_slot = message.readString();
			PhysicalPlugRule ppr = PhysicalPlugRule.parse(message);
			rule_id = -1;
			if(eau!=null) rule_id=eau.addPhysicalPlugRule(name_slot, ppr);
			success = (eau!=null && rule_id>0);
//System.out.println("success ADD_PLUG_RULE = "+success+ " dbam == null --> "+(dbam==null)+ " eau == null --> "+(eau==null)+ " agent_id = "+agent_id);			
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(PLUG_RULE_ADDED);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name_slot);
				if(success) eau.writePhysicalPlugRule(name_slot, rule_id, wcmd);				
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}		
			break;
			
		case REMOVE_PLUG_RULE:	//[REMOVE_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id]	-->  (si request_id!=0 alors une réponse est attendu)
			//[PLUG_RULE_REMOVED](int : request_id)(int: code_serveur)[bool: success](int: agent_id)(string: slot_plug)[rule_id]
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);	
			name_slot = message.readString();
			rule_id = message.readByte();
			success = (eau!=null && eau.removePhysicalPlugRule(name_slot, rule_id)==AgentU.OK);
//System.out.println("success REMOVE_PLUG_RULE = "+success+ " rule_id ="+rule_id+ " name_slot = "+name_slot);				
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(PLUG_RULE_REMOVED);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name_slot);
				wcmd.writeByte(rule_id);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}		
			break;	
		case MOVE_PLUG_RULE: //[MOVE_PLUG_RULE](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id][direction]
			//[PLUG_RULE_MOVED](int : request_id)(int: code_serveur)(int: agent_id)(string: slot_plug)[rule_id][direction]
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			agent_id = message.readInt();
			if(dbam!=null)  eau = dbam.get(agent_id);	
			name_slot = message.readString();
			rule_id = message.readByte();
			int direction = message.readByte();
			success = (eau!=null && eau.movePhysicalPlugRule(name_slot, rule_id, direction)==AgentU.OK);
			if(request_id>0){
				wcmd=DataBytes.writer();
				wcmd.writeByte(PLUG_RULE_MOVED);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(success);
				wcmd.writeInt(agent_id);
				wcmd.writeString(name_slot);
				wcmd.writeByte(rule_id);
				wcmd.writeByte(direction);
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}	
			break;
		case LOAD_SOURCE_TYPE: //[LOAD_SOURCE_TYPE](int : request_id)(int: server_code)[code_type]	-> demande de le code source du type code_type
			//[SOURCE_TYPE](int : request_id)(int: server_code)[success][code_type](s: source)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			code_type = message.readByte();
			if(request_id>0){ //aucun code source disponible pour la plateforme Java
				wcmd=DataBytes.writer();
				wcmd.writeByte(SOURCE_TYPE);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(false);
				wcmd.writeByte(code_type);
				wcmd.writeString("type not editable");
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}	
			break;
		case SET_SOURCE_TYPE: //[SET_SOURCE_TYPE](int : request_id)(int: server_code)[code_type](s: source)	-> demande de changer code source du type code_type
			//[SOURCE_TYPE_CHANGED](int : request_id)(int: server_code)[success][code_type](s:message)
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			code_type = message.readByte();
			if(request_id>0){ //aucun changement de code source disponible pour la plateforme Java
				wcmd=DataBytes.writer();
				wcmd.writeByte(SOURCE_TYPE_CHANGED);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(false);
				wcmd.writeByte(code_type);
				wcmd.writeString("type not editable");
				sender.send(SKUAD.AGENTU,  wcmd.flushReader());
			}	
			break;
		case ADD_TYPE_AGENT: //[ADD_TYPE_AGENT](int : request_id)(int: code_serveur)(string: name)
			//[TYPE_AGENT_ADDED](int : request_id)(int: code_serveur)[bool: success][code_type](string: name)[editable][error]{si error==true: (s: message_erreur)}
			request_id = message.readInt();
			dbam_id = message.readInt();
			dbam = findDBAM(dbam_id);
			name = message.readString();
			if(request_id>0){ //aucune création de type via le protocole réseau possible en Java
				wcmd=DataBytes.writer();
				wcmd.writeByte(TYPE_AGENT_ADDED);
				wcmd.writeInt(request_id);
				wcmd.writeInt(dbam_id);
				wcmd.writeBool(false);
				wcmd.writeByte(0);
				wcmd.writeString("no add type possible on this server");
				wcmd.writeBool(false);
				sender.send(SKUAD.AGENTU, wcmd.flushReader());
			}	
			break;
		}		
		message.dispose();
	}
	//]
}
