/**
 * Classe de gestion d'un agent existant
 * 
 */
package skuad.agentu.implementation;

import java.util.*;
import skuad.agentu.*;
import skuad.hubudp.*;
import skuad.agentu.implementation.amanager.ExistingAgentU;
import skuad.agentu.implementation.amanager.TypeAgent;
import skuad.util.value.Value;

public class RTExistingAgentU extends ExistingAgentU implements SpotObserver {
	
	Vector<Spot> spot_observers;
	RTAgentManager rt_manager;
	
	public RTExistingAgentU(RTAgentManager vmanager, TypeAgent ta, int aid, String vname, Value config, boolean loadSocialSlot){
		super(vmanager, ta, aid, vname, config, loadSocialSlot);
		rt_manager = vmanager;
		spot_observers = new Vector<Spot>();
	}
	
	protected void addObserver(Spot sender){
		synchronized(spot_observers){ if(getState() >= AgentU.OFF && !spot_observers.contains(sender)) {
			spot_observers.add(sender);
			sender.addSpotObserver(this);
		}}
	}
	protected void removeObserver(Spot sender){
		synchronized(spot_observers){
			spot_observers.remove(sender);
			sender.removeSpotObserver(this);
		}
	}
	
	//[Interface SpotObserver {
	public void up(Spot dspot){} 
	public void updateSMD(Spot dspot, boolean first_definition){}
	public void down(Spot dspot){ synchronized(spot_observers){ spot_observers.remove(dspot); } } //auto-purge du vecteur observers 
	public void idContext(Spot dspot, String ch_context, String id_context){}
	//]
}

