package skuad.agentu.implementation.amanager;

import java.util.*;
import skuad.uda.*;

public class HostedDevice {
	
	DeviceHoster hoster; //hote porteur du device 
	int device_id;	//id du device
	int device_type;
	String device_name;
	Vector<PhysicalSlotManager> pluggedTo;	//liste de slots sur lesquelle ce device est pluggé
	
	protected HostedDevice(DeviceHoster vhoster, int did, int dt, String vname){
//System.out.println("--new device detected, type = "+dt);
		hoster = vhoster; 
		device_id = did;
		device_type = dt;
		device_name=vname;
		pluggedTo=null;
	}
	
	public int getDeviceId() { return(device_id); }
	
	public synchronized boolean setName(String new_name) {
		if(device_name!=null && device_name.equals(new_name)) return(false);
		device_name=new_name;
		//OXO : remise en cause des plugs existant suite au changement de nom ?
		if(device_name!=null && hoster!=null) hoster.performRuleToNamedDevice(this);
		return(true);
	}
	
	public synchronized void notifyDown(){ 
		if(pluggedTo!=null){			
			for(int i=pluggedTo.size()-1; i>=0; i--) pluggedTo.get(i).unplug(false, true); //en sens inverser pour rester compatible en cas de suppression
			pluggedTo=null;
		}
		hoster=null;
	}
	
	protected synchronized Device pluggedOn(PhysicalSlotManager sm){
		if(pluggedTo==null) pluggedTo= new Vector<PhysicalSlotManager>();
		pluggedTo.add(sm);
		return(hoster.linkDevice(this));
	}
	protected synchronized void pluggedOff(PhysicalSlotManager sm, boolean remove_in_pluggedTo, Device device){
		if(pluggedTo!=null && remove_in_pluggedTo) pluggedTo.remove(sm);
		hoster.unlinkDevice(this, device);
	}

	public boolean equals(HostedDevice hd){
		return(device_id==hd.device_id && hoster.spot==hd.hoster.spot);
	}
	//]
}