package skuad.agentu.implementation.amanager;

import skuad.agentu.AgentU;
import skuad.agentu.AgentUDescriptor;
import skuad.agentu.PhysicalSpecif;
import skuad.agentu.SensorTarget;
import skuad.util.time.Pulse;
import skuad.util.value.Value;
import skuad.agentu.SocialSpecif;
import skuad.ubiquity.space.Avatar;
import skuad.uda.Device;
import skuad.uda.UDA;

public class ImplAgentUDescriptor implements AgentUDescriptor {
	ExistingAgentU iau;
	
	public ImplAgentUDescriptor(ExistingAgentU viau){
		iau=viau;
	}
	
	public int id(){ return(iau.agent_id); }
	public String getName(){ return(iau.name); }	//retourne le nom affecté à l'agent
	public String typeAgent(){ return(iau.type.name); }
	public int state(){ return(iau.state); }
	public int runMode(){ return(iau.run_mode); }	//lecture du mode d'exécution de l'agent
	public long curTime(){ return(iau.curTime()); }		//lecture du temps courant
	public Value getConfig() { return(iau.config); }
	
	public void log(String mess){ iau.log(mess); }	//message de log
	
	//Gestion des avatars
	public Avatar getAvatar(String label){ //null si l'avatar n'est pas instancié
		return(iau.getAvatar(label));
	}
	public String socialSlot(Avatar a) {
		synchronized(iau.sslots){ 
			for(SocialSlotManager mslot : iau.sslots.values()) if(mslot.avatar == a) return(mslot.slot_specif.nameSlot());
		}
		return(null);
	}

	public boolean isSocialPlugged(String slot_name) {
		return(iau.getAvatar(slot_name)!=null);
	}

	public Iterable<SocialSpecif> socialsSpecif() {
		return(iau.type.socialsSpecif());
	}
	
	//Gestion des devices
	public Device getDevice(String slot){
		PhysicalSlotManager pslot = iau.getPhysicalSlotManager(slot);
		if(pslot!=null) return(pslot.device);
		else return(null);
	}

	public void readSensor(String query_label, SensorTarget[] targets) { 
		new SensorReader(iau, query_label, targets);
	}
	
	public String physicalSlot(Device d) {
		synchronized(iau.pslots){ 
			for(PhysicalSlotManager mslot : iau.pslots.values()) if(mslot.device == d) return(mslot.slot_specif.nameSlot());
		}
		return(null);
	}

	public boolean isPhysicalPlugged(String slot_name) {
		PhysicalSlotManager pslot = iau.getPhysicalSlotManager(slot_name);
		return(pslot!=null && pslot.plugged());
	}

	public Iterable<PhysicalSpecif> physicalsSpecif() {
		return(iau.type.physicalsSpecif());
	}
	
	public boolean isReady(String slot){ 
		PhysicalSlotManager pslot = iau.getPhysicalSlotManager(slot);
		return(pslot!=null && pslot.ready);
	}
	public int trueType(String slot){ 
		PhysicalSlotManager pmslot = iau.pslots.get(slot);
		if(pmslot!=null) return(pmslot.true_type);
		else return(UDA.NOT_EXIST); 
	}
	
	//Rythme du comportement
	public Pulse pulse(String label, long delay,  boolean fire_uptodate){
		if(iau.state>AgentU.OFF){
			Pulsor pulsor = iau.newPulsor(label, delay, 0, fire_uptodate); //new Pulsor(iau, label, delay, fire_uptodate);
			return(pulsor);
		}
		return(null);
	}
	public Pulse loopPulse(String label, long delay,  long periode, boolean reset_on_resume){
		if(iau.state>AgentU.OFF){
			Pulsor pulsor = iau.newPulsor(label, delay, periode, reset_on_resume); //new Pulsor(iau, label, delay, periode, reset_on_resume);
			return(pulsor);
		}
		return(null);
	}
}