package skuad.agentu.implementation.amanager;

import skuad.util.value.Value;
import skuad.util.value.ValueWriter;
import skuad.agentu.AgentU;
import skuad.agentu.SensorTarget;
import skuad.uda.Device;
import skuad.uda.monitor.MinimalMonitor;

public class SensorReader {
	
	ExistingAgentU iau;
	String query_label;
	ValueWriter writer;
	int count;
		
	public SensorReader(ExistingAgentU viau, String vquery_label, SensorTarget[] targets) {
		iau = viau;
		query_label = vquery_label;
		writer = Value.writer();
		count = targets.length;
		
		for(int i=0; i<targets.length; i++) {
			SensorTarget cur = targets[i];
			Device device = viau.aud.getDevice(cur.getNameSlot());
			if(device!=null) new InternalSensorReader(this, cur, device);
			else setField(cur, SensorTarget.NO_PLUG, Value.NULL_VALUE);
		}
	}
	
	protected synchronized void setField(SensorTarget starget, int state, Value value) {
		Value val = Value.writer().set("state", state).set("slot", starget.getNameSlot()).set("sid",starget.getSensorId()).set("value", value).toConstant();
		writer.set(starget.getLabel(), val);
		count--;
		if(count==0 && iau.state==AgentU.RUN) iau.agent.sensorReading(iau.aud, query_label, writer.toConstant());
	}
}

class InternalSensorReader extends MinimalMonitor {
	
	SensorReader master;
	SensorTarget starget;
	
	protected InternalSensorReader(SensorReader m,  SensorTarget st, Device device) {
		master = m;
		starget = st;
		device.readSensor(this, starget.getSensorId());
	}
	
	public void sensorValue(Device dev, int sensor_id, int value){
		master.setField(starget, SensorTarget.OK, Value.i(value));
	}

	public void sensorValue(Device dev, int sensor_id, float value){
		master.setField(starget, SensorTarget.OK, Value.f(value));		
	}
	public void sensorValue(Device dev, int sensor_id, byte[] value){
		master.setField(starget, SensorTarget.OK, Value.bs(value));	
	}
}