/**
 * Classe de facilitation d'implémentation d'un agent (toutes les méthodes AgentU sont vide)
 */
package skuad.agentu.util;

import skuad.ubiquity.space.Avatar;
import skuad.ubiquity.space.mailbox.MailBox;
import skuad.ubiquity.space.mailbox.Message;
import skuad.uda.*;
import skuad.util.time.Pulse;
import skuad.util.value.Value;
import skuad.agentu.*;

public class AgentUAdapter implements AgentU {
	
	//Cycle de vie de l'agent
	public void init(AgentUDescriptor aud){}		//invoqué suite à l'instanciation de l'agent (avant son démarrage via start)
	public void start(AgentUDescriptor aud, int ctx){}	//invoqué au démarrage de l'agent
	public void stop(AgentUDescriptor aud, int ctx){}		//invoqué lors de la mise à l'arret de l'agent
	public void event(AgentUDescriptor aud, int code, int ctx){} //code = PAUSE / RESUME / ALL_PLUGGED / MISSING_PLUG
	
	//Exécution du comportement de l'agent
	public void behavior(AgentUDescriptor aud, Pulse pulse){} //exécute le comportement de l'agent suite à l'activation d'un pulse, pulse = le descripteur de la pulsation qui a initié cet appel	
	public void inoperablePulse(AgentUDescriptor aud, Pulse pulse){}	//signal que le pulse devrait déclencher le comportement, mais qu'il n'est pas opérable car l'état de l'agent n'est pas IN_RUN
	
	//Devices attachés à l'agent
		//évènement d'attachement de device
	public void notifyPlugDevice(AgentUDescriptor aud, String slot, Device device){}
	public void notifyUnplugDevice(AgentUDescriptor aud, String slot){}
	public void notifyChangeDevice(AgentUDescriptor aud, String slot, Device device){}
	
		//Ecoute des devices
	public void stateDevice(AgentUDescriptor aud, String slot, Device dev, boolean ready, boolean config_changed){} //invoqué dès que l'état du device évolue
	public void sensorReading(AgentUDescriptor aud, String read_label, Value value) {}
	public void sensorChange(AgentUDescriptor aud, String slot, int sensor_id, Value value) {}
	
	//Avatars associés à l'agent
		//évènement d'attachement des avatars
	public void notifyPlugAvatar(AgentUDescriptor aud, String name, Avatar avatar, int contexte){}
	public void beforeUnplugAvatar(AgentUDescriptor aud, String name, Avatar avatar, int contexte){} //change_space==true s'il s'agit d'un changement d'avatar
	public void notifyUnplugAvatar(AgentUDescriptor aud, String name, int contexte){}
	public void receive(AgentUDescriptor aud, Avatar avatar, MailBox box, Message mess){}
	
	
	//[A supprimer
	/**
	 * @deprecated remplacé par sensorChange(...)
	 */
	@Deprecated
	public void sensorValue(AgentUDescriptor aud, String slot, Device dev, int sensor_id, int value){}
	/**
	 * @deprecated remplacé par sensorChange(...)
	 */
	@Deprecated
	public void sensorValue(AgentUDescriptor aud, String slot, Device dev, int sensor_id, float value){}
	/**
	 * @deprecated remplacé par sensorChange(...)
	 */
	@Deprecated
	public void sensorValue(AgentUDescriptor aud, String slot, Device dev, int sensor_id, byte[] value){}	
	//]
}