package skuad.hubudp;

/**
*	<em>HubListeners</em> are listeners that you have to assign to a <em>Hub</em> to capture all events notifications in a <em>Hub</em>.
*	See the <em>Hub</em> class to know the code of each event.
*/
public interface HubListener {
	/**
	* Will be called each time an event is triggered, with the corresponding event code.
    * @param Hub
    * 			The Hub you want to hear all event notifications. 
    * @param event
    * 			The event code that correspond to an event.
    * @param args
    * 			TODO
    * @see Hub
    *
    */
	public void hubEvent(Hub hub, byte event, String args); 
	
}