package skuad.hubudp;
/**
*	<em>HubReadyListener</em> is a specific listener used to notify the event HUB_READY that corresponds to the fact that the
*   <em>Hub</em> Object is ready to use after the initialization of the <em>LocalSpot</em> in the <em>Hub</em> you just joined.
*/
public interface HubReadyListener {
	
	/**
	* Will be called each time an event is triggered, with the corresponding event code.
    * @param Hub
    * 			The Hub you want to hear all event notifications. 
    * @param localspot
    * 			The <em>LocalSpot</em> initialized in the Hub you just joined.
    * @see Hub
    * @see LocalSpot
    *
    */
	public void ready(LocalSpot localspot);
	
}