package skuad.hubudp;

import skuad.util.databytes.*;

/**
 * A MessageReceiver is the objet that handle receiving messages.
 * @see Spot
 */
public interface MessageReceiver {
	/**
	 * Receive is called when a message is received. Each reception create a process.
	 * After reading, you have to apply <i>dispose()</i> on the message.
	 * @param sender The <i>Spot</i> which send the message.
	 * @param message The received message.
	 * @param channel The channel in which the message was sent.
	 * @see Spot
	 * @see DataReader
	 */
	public void receive(Spot sender, DataReader message, int channel);
		//--> cette méthode sera déclenché dans un processus dédié
		// /!\ aprés lecture, on doit appliquer un .dispose() sur le message
}