package skuad.hubudp;

/**
 * The SpotObserver is the object which has to notify <i>Spot</i> events.
 * @see Spot
 * @see Hub
 */
public interface SpotObserver extends IdContextExplorer {
	
	/**
	 * UP is the event which is raised when a <i>Spot</i> appears in the <i>Hub</i>.
	 * @param spot The source <i>Spot</i> of the event. 
	 */
	public void up(Spot spot); 
	/**
	 * DOWN is the event which is raised when a <i>Spot</i> leaved the <i>Hub</i>.
	 * @param spot The source <i>Spot</i> of the event.
	 */
	public void down(Spot spot); //NB: jamais invoqué sur le spotLocal

	/**
	 * UPDATESMD is the event which is raised when a <i>Spot</i> fixed his <i>SMD</i>.
	 * @param spot The source <i>Spot</i> of the event.
	 * @param first_definition TODO
	 */
	public void updateSMD(Spot spot, boolean first_definition);
	
}