package skuad.hubudp.implementation;

import skuad.util.databytes.DataBytes;
import skuad.util.databytes.DataReader;
import skuad.util.databytes.DataWriter;
import skuad.hubudp.implementation.local.HubLocal;
import skuad.util.base.Network;
import skuad.hubudp.implementation.portal.*;

public class ManagedSpotProxy extends SpotImpl implements ManagedSpot {
	
	HubLocal localhub;
	Linker linker;
	int jid;
	
	public ManagedSpotProxy(HubLocal vhub, int vctarget, int p, Linker vl, int vjid) {
		super(vhub, vctarget, p);
		localhub = vhub;
		linker = vl;
		jid=vjid;
	}
	public String getIp() { return(Network.LOCALHOST); }
	public boolean isLocalEContext() { return(true); }
	
	public void changeCTargetAndPort(int vctarget, int vport) {
		this.changeIdTarget(vctarget);
		this.changePort(vport); 
	}
	public boolean isLinkedTo(Linker l) { return(linker == l); }
	public int getJid() { return(jid); }
	
	//[Interface ManagedSpot
	public HubLocal getLocalHub() {
		return(localhub);
	}
	//]

	public void queryGet(SpotSender sender) {
		//[ALL_ID_CONTEXT](int: nb_id_context)|...pour chaque id: (string: chaine_context)(string: id_context) ...|
		synchronized(idContexts){
			DataWriter dw = DataBytes.writer().b(ProtocoleSpot.ALL_ID_CONTEXT).i(idContexts.size());
			for(String ctx : idContexts.keySet()){
				dw.s(ctx).s(idContexts.get(ctx));
			}
			sender.isend(this, -1, dw.flushReader(), true, true); 
		}
		//[SMD][def_version](i: nb_value)|...pour chaque valeur: (i: code)[value_size]{...value...}...|
		sender.isend(this, -1, getDefSMD(), true, false);
	}

	public void queryTag(SpotSender sender, String name) {
		linker.queryTag(jid, sender.getSpot(), name); //on doit remonter la demande jusqu'au portail, pour qu'il la relègue au joiner distant		
	}

	public boolean isLocalHost() { return (false); }

	public boolean isend(SpotSender sender, int channel, byte content, boolean need_ack) {
		DataWriter mess = DataBytes.writer().b(content);
		return(ireceive(sender, channel, mess.flushReader(), true));
	}
	public boolean isend(SpotSender sender, int channel, DataReader content, boolean need_ack, boolean auto_dispose) {
		return(ireceive(sender, channel, content, auto_dispose));
	}
	public boolean isend(SpotSender sender, int channel, byte[] buff, int offset, int size, boolean need_ack) {
		DataWriter mess = DataBytes.writer();
		mess.copyBytes(buff, offset, size);
		return(ireceive(sender, channel, mess.flushReader(), true));
	}
	public boolean ireceive(SpotSender sender, int channel, DataReader content, boolean auto_dispose) {
		if(isUp()) {
			hub.performMessage(sender, this, channel, content.clone()); 
			if(auto_dispose) content.dispose();
			return(true);
		}
		return(false);	
	}
	
	public void receiveAppMessage(SpotSender sender, int channel, DataReader mess) {
		linker.receiveAppMessage(jid, sender.getSpot(), channel, mess); //on doit remonter la demande jusqu'au portail, pour qu'il la relègue au joiner distant		
	}
}