package skuad.hubudp.implementation.local;

public class ProtocoleLocal {
	
	//[Constantes générales
	public final static int MASTER_PORT	= 8266; 		//port maitre du protocole
	public final static int MAX_UDP_BUFFER_SIZE = 500;	//taille maximum des paquets UDP à échanger sur le réseau (la taille maxi ESP8266 est de 512 octets)
	public final static int HEAD_SPOT_SIZE = 20;		//taille de l'entête des messages du protocole SPOT
	public final static int CONTENT_SPOT_SIZE = MAX_UDP_BUFFER_SIZE-HEAD_SPOT_SIZE;
	public final static int MAX_RESEND	= 20;		//nombre maximum de ré-emission d'un même paquet 
	//]
	
	//[-----------> pour la synchro globalMap et localMap entre les NS et leur NM local
		//maintient à jour de la localMap
	//ADD identique à celui our la diffusion entre NM // *bs* [85][ADD](short: rand_instance)(short: new_loacalmap_version)(s: id_hub)(short: ctarget)(short: port)(short: rinstance)  <- le NM signal une maj de la localMap
// *bs* [85][REMOVE](short: rand_instance)(short: new_loacalmap_version)(s: id_hub) (short: ctarget)
	//en cas de désynchro de version, le NS envoie une demande GET_LOCALMAP au NM
	public final static byte ADD_DISTANT 	= 20;	// *bs* [85][ADD_DISTANT](short: master_rand_instance)(short: globalmap_version)(dword: ip)(short: ip_rand_instance)(short: ipmap_version)(s: id_hub)(short: ctarget)(short: port)(short: rinstance) 
	public final static byte REMOVE_DISTANT = 21;	// *bs* [85][REMOVE_DISTANT](short: master_rand_instance)(short: globalmap_version)(dword: ip)(short: ip_rand_instance)(short: ipmap_version)(s: id_hub) (short: ctarget)(short: port)(short: rinstance) 
	public final static byte CHANGE_MASTER 	= 22;	// *bs* [85][CHANGE_MASTER](short: master_rand_instance)(short: globalmap_version)(dword: ip)(short: new_ip_rand_instance) <- changement du rand_instance d'un NM
	public final static byte ADD_MASTER 	= 23;		// *bs* [85][ADD_MASTER](short: master_rand_instance)(short: globalmap_version)(dword: ip)(short: ip_rand_instance)
	public final static byte REMOVE_MASTER 	= 24;	// *bs* [85][REMOVE_MASTER](short: master_rand_instance)(short: globalmap_version)(dword: ip)(short: ip_rand_instance) <- suppression d'un master ==> tous ses spots devront être retiré de la globalMap et être passé à down

		//maintient à jour de la globalMap
	public final static byte MASTER_PULSE 	= 25;// *bs* [85][MASTER_PULSE](short: rand_instance)(short: localmap_version)(short: globalmap_version)(short: slave_list_version)
	//en cas de désynchro de globalmap_version, le NS envoie une demande GET_IPLIST au NM
	//en cas de désynchro de localmap_version, le NS, ou le NM distant, envoie une demande GET_LOCALMAP au NM local
	//en cas de désynchro de slave_list_version, le NS envoie une demande GET_SLAVELIST au NM
	public final static byte SLAVE_PULSE 	= 26;//[85][SLAVE_PULSE](short: rand_instance)
	//en cas de mauvais rand_instance, le NM envoie une demande GET_SPOTLIST au NS
	//[85][SLAVE_DOWN](short: rand_instance)
	public final static byte ADD_SLAVE 		= 27; 	// *bs* [85][ADD_SLAVE](short: master_rand_instance)(short: new_slavelist_version)(short: port)(short: rand_instance)	
	public final static byte REMOVE_SLAVE 	= 28;	// *bs* [85][REMOVE_SLAVE](short: master_rand_instance)(short: new_slavelist_version)(short: port)(short: rand_instance)
	
		//NM -> NS
	public final static byte GET_SPOTLIST 	= 30;	// [85][GET_SPOTLIST]		<- la réponse sera un (ou plusieurs message) SPOTLIST
	public final static byte SPOTLIST 		= 31;		//[85][SPOTLIST](short: rand_instance)[page][nb_page] {...| (s: id_hub)(i:nb_target) $ {...|  (short: ctarget) $ |...} |...}
		//NS -> NM
	public final static byte GET_SLAVELIST 	= 32; // [85][GET_SLAVELIST]		<- la réponse sera un (ou plusieurs message) SLAVELIST
	public final static byte SLAVELIST 		= 33; 	// [85][SLAVELIST](short: rand_instance)(short: slavelist_version)[page][nb_page]{...| (short: rand_instance)(short: port) $ |...}
	public final static byte GET_GLOBALMAP 	= 34;//[85][GET_GLOBALMAP]		<- le NS a détecté une désycnrho de sa globalMap, il demande au NM sa global via ce message. La réponse sera un (ou plusieurs message) GLOBALMAP
	public final static byte GLOBALMAP  	= 35;//[85][GLOBALMAP](short: rand_instance)(short: globalmap_version)[page][nb_page]
			//{...| 
			//		(dword: ip)(short: ip_rand_instance)(short: ipmap_version)(short: nb_hub) $ {...| (s: id_hub)(i:nb_target) $ {...|  (short: ctarget)(short: port)(short: rinstance)  $ |...} |...} 
			//|...}
			//	==> $ désigne une position de coupure potentielle entre les paquets
	
		//demande de création d'un spot par un NS et validation de sa création
	public final static byte QUERY_PLUG 	= 36; 	// [85][QUERY_PLUG](s: id_hub)				<- un NS demande au NM un ctarget pour le spot local qui lui permettra de se connecter au hub indiqué
	public final static byte DENY_PLUG 		= 37; 	// [85][DENY_PLUG](s: id_hub)(s: mess)(short: ctarget)(short: possible_new_ctarget)	<- le NM répond par la négative à une demande QUERY_PLUG (ctarget ==0 si c'est suite à un QUERY_PLUG) 
	public final static byte ACCEPT_PLUG 	= 38; 	// [85][ACCEPT_PLUG](s: id_hub)(short: ctarget)	<- le NM accepte un demande QUERY_PLUG et propose la valeur ctarget à utiliser
		//le NM va attendre le message [READY_PLUG] avant de prendre réellement en compte la création du spot 
		// et notifier son existence de ctarget vers les autres noeud du réseau (message ADD)
	public final static byte READY_PLUG 	= 39;  // [85][READY_PLUG](short: rinstance)(s: id_hub)(short: ctarget) <- le NS signal que son spot local est pret, c'est le signal pour le NM de prendre véritablement en compte cette existance
	
		/*Q: Comment gérer les demandes PLUG/READY en attentes en cas de changement brutal de NM ?
	 	--> les demandes PLUG seront renouvellées automatiquement vers le nouveau NM
	 	--> les demandes READY seront concidéré comme valide par le nouveau NM si elle ne vient pas entrer en conflit
	 		avec un ctarget déjà existant, dans le cas contraire il envera une demande replug au noeud demandeur
	 		==> pour limiter ce cas de figure, quand un nouveau NM prend son rôle il va régler son next_ctarget
	 		sur une valeur +100 de la plus grande valeur ctarget existante.
		 */
	//]
	//[-----------> pour le broadcast de diffusion, et le maintient, de la hubMap entre NM
		//maintient à jour de la global map sur l'ensemble des noeuds
	public final static byte ADD_LOCAL 		= 40; 	//* B* [85][ADD_LOCAL](short: rand_instance)(short: my_ipmap_new_version)(s: id_hub) (short: ctarget)(short: port)(short: rinstance)
	public final static byte REMOVE_LOCAL 	= 41;  //*B* [85][REMOVE_LOCAL](short: rand_instance)(short: my_ipmap_new_version)(s: id_hub) (short: ctarget)(short: port)(short: rinstance)
		//--> en cas de désynchro de ipmap_new_version, le noeud enverra une demande GET_LOCALMAP
	//demande de localmap d'un noeud
	public final static byte GET_LOCALMAP 	= 42;//[85][GET_LOCALMAP]		<- la réponse sera un (ou plusieurs message) LOCALMAP
	public final static byte LOCALMAP 		= 43;//[85][LOCALMAP](short: rand_instance)(short: my_ipmap_version)[page][nb_page]{...| (s: id_hub)(i:nb_target) $ {...|  (short: ctarget)(short: port)(short: rinstance)  $ |...} |...}
											//	==> $ désigne une position de coupure potentielle entre les paquets
	//]
	
	public final static byte DOWN 			= 66; //[85][DOWN](sh: randi) <- le noeud émetteur siganle la fin de son exécution
}