package skuad.hubudp.implementation.portal;

import skuad.hubudp.*;
import skuad.util.databytes.*;
import skuad.hubudp.implementation.*;

public interface HubLinker {
	public String getHubName();
	public void connectionError(Linker l, String err_mess); //le linker signal une erreur au moment de la tentative de connection
	public void linked(Linker l); 	//le linker signal que sa liaision avec le portail est établie
	public void unlinked(Linker l, String err_mess); //le linker signal que sa liaision avec le portail est perdue
	public void addSpotProxy(Linker vl, int vjid); //demande l'enregistre d'un nouveau spot proxy, --> l'appel linker.notifyProxyAdded(...) sera déclenché quand l'ajout sera effectif
	public void removeSpotProxy(Linker vl, int vjid);
	public ManagedSpotProxy getSpotProxy(Linker vl, int vjid);
	public void addSpotObserver(SpotObserver observer); //dès son enregistrement l'observer recoit tous les évènements up pour chaque spot UP et les IdContext déjà produit sur ces spots, ainsi qu'un updateSMD(spot, true) pour les spots qui ont déjà inintialisés leur SMD
	public boolean removeSpotObserver(SpotObserver observer);
	public DataReader getRawSMD(Spot spot);
	public int getInternalVersionSMD(Spot spot);
	public void ibroadcastByte(SpotSender sender, int channel, byte content, int option);
	public void ibroadcastBuff(SpotSender sender, int channel, byte[] buff , int offset, int size,  int option);
	public void ibroadcast(SpotSender sender, int channel, DataReader content, int option);
	public void internal_send(SpotSender sender, String  ip_target, int ctarget, int channel, DataReader content, boolean need_ack);
	public void internal_sendByte(SpotSender sender, String ip_target, int ctarget, int channel, byte content, boolean need_ack);
	public void internal_sendBuff(SpotSender sender, String ip_target, int ctarget, int channel,  byte[] content, boolean need_ack);
}