//Support d'exécution d'agent en temps réel
package skuad.sim;

import skuad.sim.implementation.*;
import skuad.sim.simop.*;
import skuad.sim.implementation.simamanager.*;

public class SimAU implements SimPilot {
	
	SimProcess sim_process;
	String name;
	
	//[Constructeurs
	public SimAU(String vname){
		name=vname;
		sim_process = new SimProcess(this, new AgentUSimContext());
	}
	public String getName() { return(name); }
	public int getProcessState() { return(sim_process.getProcessState()); } //état courant de la simulation
	
	public void addInitializer(SimInitializer simInit) { sim_process.addInitializer(simInit); }  
	public boolean removeInitializer(SimInitializer simInit) { return(sim_process.removeInitializer(simInit)); }
	//]
		
	//[Gestion des observeurs
	public void addSimObserver(SimObserver simo)  { sim_process.addSimObserver(simo); }  
	public boolean removeSimObserver(SimObserver simo) { return(sim_process.removeSimObserver(simo)); }
	public void addResetListener(ResetListener rlisten)  { sim_process.addResetListener(rlisten); }  
	public boolean removeResetListener(ResetListener rlisten) { return(sim_process.removeResetListener(rlisten)); }	
	//]
	
	//[Pilotage de la simulation
	public boolean start() { return(sim_process.cmd(SimProcess.TO_START)); }
	public boolean reset() { return(sim_process.cmd(SimProcess.TO_RESET)); } //réinitialise toutes les Sim Opération
	public boolean stop() { return(sim_process.cmd(SimProcess.TO_STOP)); }
	public boolean pause() { return(sim_process.cmd(SimProcess.TO_PAUSE)); }
	//]
}