package skuad.sim.implementation;

import skuad.sim.*;
import skuad.util.time.Pulse;
import skuad.sim.simop.*;
import skuad.util.time.temporality.*;

public class InternalPulsable implements PulsableDescriptor, PulseTarget{
	
	Pulsable pulsable;
	SimPilot spilot;
	SimContext scontexte;
	
	public InternalPulsable(SimPilot vspilot, SimContext vscontexte, Pulsable vpulsable) {
		spilot= vspilot;
		scontexte = vscontexte;
		pulsable = vpulsable;
	}
	
	public void start() {
		pulsable.start(spilot, this, scontexte.startSimOperation());
	}
	public void stop(boolean stop_client) {
		if(pulsable!=null) {
			if(stop_client) pulsable.stop(spilot);
			pulsable=null; //conduira à nétoyer les pulses périodique encore actif sur ce pulsable
		}
	}

	public Pulse pulse(String label, long delay) {
		if(pulsable!=null) return(scontexte.newPulse(this, label, delay));
		else return(null);
	}

	public Pulse loopPulse(String label, long delay, long periode) {
		if(pulsable!=null) return(scontexte.newPulse(this, label, delay, periode));
		else return(null);
	}
	
	//[Interface PulseTarget
	public void run(Pulse pulse) {
		if(pulsable!=null) pulsable.behavior(spilot, this, pulse, scontexte.startSimOperation(), scontexte.runSimOperation());
		else pulse.cancel();
	}
	//]
}