/**
	Classe de gestion de la liste des agents et des types d'agents existants 
	
	 Syntaxe du fichier d'enregisrement pour le mode persistant :
	 
	 <dbagent next_agent_id='xxx'  next_code_type='xxx' >
	 
	 	//pour chaque type d'agent existant
	 	<type id = 'xxx'  name = 'xxx' class_name='xxxx' />
	 
	 	//pour chaque agent existant
	 	<agent id='xxx' name='xxx' type='xxx' run_mode='xxx'>
	 		
	 		//slot social de l'agent 
	 		<socialSlot name='xxx' space="name_space" password="...." local_id="..." />   //password et local_id optionnel

	 		...
	 	
	 		//slot physique ouvert de l'agent (ceux disposant d'au moins une règle)
	 		<physicalSlot name='xxx' >
	 			//pour chaque règle plug
	 			<rule id='xxx' 
	 				node_key='' node_value='' 
	 				spot_key='' spot_value='' 
	 				device_key='' device_value=''  
	 			/>
	 			...
	 		</physicalSlot>
	 		
	 		...
	 		
	 	</agent>
	 
	 	...
	 	
	 </dbagent>
 */
package skuad.sim.implementation.simamanager;

import skuad.agentu.AgentU;
import skuad.agentu.implementation.amanager.*;
import skuad.sim.simop.*;

public class SimAgentManager extends AgentManager implements RunSimOperation {

	AgentUSimContext auscontext;
	
	public SimAgentManager(AgentUSimContext vauscontext){ 
		auscontext=vauscontext;
	}
	
	//[Implémentation de AgentManager
	public RunAgentContext getRunContext() { return(auscontext); }
	
	protected Pulsor newPulsor(ExistingAgentU eau, String label, long delay, long periode, boolean fireUptodate_or_resetOnResume) {
		return(new SimPulsor(auscontext, eau, label, delay, periode, fireUptodate_or_resetOnResume));
	}
	//]
	
	public void startAllAgent() { //on demarre les agents qui ont besoin de l'être
		startAllAgent(AgentU.INIT_SERVER);
	}
	public void stopAllAgent() {//on demarre les agents qui ont besoin de l'être
		stopAllAgent(AgentU.SHUTDOWN);
	}
	
}