package skuad.sim.simop;

import skuad.agentu.*;
import skuad.util.base.ConstantIterable;
import skuad.hubudp.SpotExplorer;
import skuad.hubudp.SpotObserver;
import skuad.sim.VirtualSpot;

public interface ReadSimOperation { //Opération de lecture possibles à tout moment de la simulation
	
	//[Configuration des générales
	public int getState();
	public long curTime();
	
	public long getStartTime();
	public long getPingTime();
	public long getEndTime();
	//]
		
  //[[AGENTU
	//[Configuration des spots
	public void  addSpotObserver(SpotObserver obs);   
	public boolean removeSpotObserver(SpotObserver obs);
	public void explore(SpotExplorer cb, boolean include_down_spot);
	//]
		
	//[Gestion des types d'agent
	public Iterable<String> namesTypeAgent();	//retourne la liste des types agents existant
	public int codeTypeAgent(String name_type_agent);
	//]		
	
	//[Consultation des agents
	public void addAllAgentObserver(AgentUObserver obs);  
	public boolean removeAllAgentObserver(AgentUObserver obs);
	
	public boolean addAgentObserver(int agentId, AgentUObserver obs);
	public boolean removeAgentObserver(int agentId, AgentUObserver obs);

	public Iterable<Integer> allAgentsId();
	public Iterable<Integer> agentsId(String agent_name);
	public boolean existAgent(int agentId);
	public boolean existAgentWithName(String agent_name);
	
	public int agentType(int agentId);
	public String agentTypeName(int agentId);
	public String agentName(int agentId);
	public byte agentState(int agentId);
	public byte agentRunMode(int agentId);
	//]
	
	//[Configuration des agents
	public ConstantIterable<SocialSpecif> socialsSpecif(int code_type_agent);
	public ConstantIterable<SocialSpecif> socialsSpecif(String name_type_agent);
	public String getSocialPlugNameSpace(int agentId, String name_slot);
	public boolean isSocialPlugPrivateSpace(int agentId, String name_slot);
	public String getSocialSlotConfigLocalId(int agentId, String name_slot);

	public boolean existSocialPlug(int agentId, String name_slot);
	public String getSocialPlugCurrentLocalId(int agentId, String name_slot);
	
	public ConstantIterable<PhysicalSpecif> physicalsSpecif(int code_type_agent);
	public ConstantIterable<PhysicalSpecif> physicalsSpecif(String name_type_agent);
	public Iterable<Integer> physicalPlugRules(int agentId, String name_slot);
	
	public boolean physicalSlotPlugged(int agentId, String name_slot);
	public VirtualSpot getPhysicalPlugSpot(int agentId, String name_slot);
	public int getPhysicalPlugDeviceId(int agentId, String name_slot);
	//]	
  //AGENTU]]		
}