package skuad.sim.simop;

import skuad.sim.*;

public interface SimPilot {
	
	//[Constante d'état du process de la simulation
	public final static int OFF=1;
	public final static int INITIALIZING=2;
	public final static int IN_RUN=3;
	public final static int PAUSE_PLANNED=4;	//état transitoire
	public final static int PAUSED=5;
	public final static int RESUMED=6;			//état transitoire
	public final static int STOPPED=7;
	public final static int ENDED=8;
	//]
	
	//[Constante des évènements observables
	public final static int SIM_INIT=1;		//SYNC : tous les initisaliseurs vont être déclenchés
	public final static int SIM_START=2;	//SYNC : début de la simulation
	public final static int SIM_PAUSE=3;	//ASYNC: mise en pause
	public final static int SIM_RESUME=4;	//SYNC: reprise de la simulation
	public final static int SIM_STOP=5;		//SYNC: simulation mis à l'arret
	public final static int SIM_END=6;		//SYNC:	fin de la simulation
	public final static int SIM_RESET=7;	//ASYNC:		

	public final static int BEGIN_CYCLE=10;	//SYNC : tous les pulses du tc courant vont être déclenchés
	public final static int END_CYCLE=11;	//SYNC : fin des traitement des pulses du tc courant
	//]

	public String getName();
	public int getProcessState();
	
	public void addInitializer(SimInitializer simInit);  
	public boolean removeInitializer(SimInitializer simInit);
	//]
		
	//[Gestion des observeurs
	public void addSimObserver(SimObserver simo);  
	public boolean removeSimObserver(SimObserver simo);	
	//]
	
	//[Pilotage de la simulation
	public boolean start();
	public boolean reset(); //réinitialise toutes les Sim Opération
	public boolean stop();
	public boolean pause();
	//]
}