package skuad.sim.simop;

import skuad.util.databytes.DataReader;
import skuad.util.value.Value;
import skuad.sim.*;
import skuad.uda.Device;
import skuad.agentu.AgentU;
import skuad.agentu.PhysicalPlugRule;

public interface StartSimOperation extends ReadSimOperation { //Opération possibles au moment du lancement de la simulation
	
//Ecriture
	//[Configuration des générales
	public boolean loadXeloc(String filename); //seuls les opérations permise en fonction de l'état de la simulation seront traité
	//]

	public void log(String mess);
	
	//[Gestion des environnements virtuels
	public void addVirtualEnv(VirtualEnv venv);
	public boolean removeVirtualEnv(VirtualEnv venv);
	//]
	
	//[Gestion des pulsables
	public void addPulsable(Pulsable pulsable);
	public boolean removePulsable(Pulsable pulsable);
	//]

  //[[AGENTU		
	//[Configuration des spots
	public void setHostRootSMD(String host_ip, String host_name);
	public void setHostRootSMD(String host_ip, SmdValue[] smd);
	public VirtualSpot newSpot(String host_ip);
	public VirtualSpot localspot(); //récupération du spot local virtuel
	public PhysicalPlugRule addDevice(Device d); //crée et retourne un nouveau spot et lui affecte le device indiqué
	public boolean removeDevice(Device d);	//suppression du device indiqué
	//]	
	
	//[Gestion des types d'agent
	public int addTypeAgent(Class<? extends AgentU> classe);
	public int addTypeAgent(String type_name,  Class<? extends AgentU> classe);
	//]
	
	//[Création/suppresion des agents
	public int createAgent(Class<? extends AgentU> classe, String agent_name, Value config);
	public int createAgent(int code_type, String agent_name, Value config);
	public int createAgent(String type_name, String agent_name, Value config);
	public int createAgent(Class<? extends AgentU> classe, String agent_name);
	public int createAgent(int code_type, String agent_name);
	public int createAgent(String type_name, String agent_name);
	public boolean removeAgent(int agent_id);
	//]
			
	//[Configuration des agents
	public boolean changeRunModeAgent(int agentId, byte run_mode);
	public byte setSocialPlug(int agentId, String name_slot, String name_space, String password, String local_id);
	public int addPhysicalPlugRule(int agentId, String name_slot, DataReader rule);
	public int addPhysicalPlugRule(int agentId, String name_slot, String rule);
	public int addPhysicalPlugRule(int agentId, String name_slot, Value rule);
	public int addPhysicalPlugRule(int agentId, String name_slot, PhysicalPlugRule rule);
	public byte movePhysicalPlugRule(int agentId, String name_slot, byte rule_id, byte direction);
	public int removePhysicalPlugRule(int agentId, String name_slot, byte rule_id);
	//]
  //AGENTU]]	
	
	//[A supprimer
	/**
	 * @deprecated remplacé par addVirtualEnv(...)
	 */
	@Deprecated
	public void addVirtaulEnv(VirtualEnv venv);
	/**
	 * @deprecated remplacé par removeVirtualEnv(...)
	 */
	@Deprecated	
	public boolean removeVirtaulEnv(VirtualEnv venv);
	//]
	
}