package skuad.sim.ui;

import java.awt.BorderLayout;
import java.awt.Container;
import javax.swing.*;
import skuad.sim.simop.*;

public class SimFrame extends JFrame {
		
	SimSpeedClock ssc; 
	
	public SimFrame(SimPilot simpilot, boolean exit_on_close) {
		super(simpilot.getName());
		
		if(exit_on_close) setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container content = getContentPane();
		content.setLayout(new BorderLayout());

		SimLogger logger = new SimLogger(simpilot);
		content.add(logger, BorderLayout.CENTER);
		JPanel panel=new JPanel();
		ssc = new SimSpeedClock(simpilot);
		panel.setLayout(new BorderLayout());
		panel.add(new SimControlBar(simpilot, ssc), BorderLayout.WEST);
		panel.add(new SimProgressBar(simpilot), BorderLayout.CENTER);
		panel.add(ssc, BorderLayout.SOUTH);
		add(panel, BorderLayout.NORTH);
		
		setBounds(100, 100, 450, 300);
	}
/*	
	//Lancement autonome
	public static void main(String[] args) {
		JFrame frame=new SimFrame(new SimAU("Test 1"), true);
		frame.setBounds(100, 100, 450, 300);
		frame.setVisible(true);
	}
	*/
	
	public void setLevelSpeed(int speed) {
		ssc.setLevelSpeed(speed);
	}
}
