package skuad.sim.ui;

import javax.swing.*;
import skuad.hubudp.Spot;
import skuad.sim.simop.*;
import skuad.sim.*;
import java.awt.*;
import skuad.agentu.*;
import skuad.util.time.*;

public class SimLogger extends JPanel implements SimObserver, AgentUObserver {
	
	JTextArea txt_area;
	JScrollBar verticalBar;
	
	public SimLogger(SimPilot simpilot) {
		txt_area = new JTextArea();
		txt_area.setEditable(false);
		setLayout(new BorderLayout());
		JScrollPane scpane = new JScrollPane(txt_area);		
		verticalBar = scpane.getVerticalScrollBar();
		add(scpane, BorderLayout.CENTER);
		
		if(simpilot!=null) simpilot.addSimObserver(this);
	}
	
	public void addLog(String mess) {
		txt_area.append(mess+"\n");
		
		int pos = verticalBar.getValue();
		int max = verticalBar.getMaximum();
		int H = verticalBar.getHeight();
//System.out.println("pos = "+pos+" // max = "+max+"  H = "+verticalBar.getHeight()+"   v = "+(max-(pos+H)));		
		if(max-(pos+H)<50) verticalBar.setValue(max);
	}
/*	
	//Lancement autonome
	public static void main(String[] args) {
		JFrame frame=new JFrame("SimLogger");
		frame.setBounds(100, 100, 200, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//mep
		SimLogger cb = new SimLogger(new SimAU("Test 1"));
		Container content = frame.getContentPane();
		content.setLayout(new BorderLayout());
		content.add(cb, BorderLayout.CENTER);
		frame.setVisible(true);
		
		ThreadStack.perform(()->{
			for(int i=0; i<30; i++) cb.addLog("Coucou");
			 //cb.addLog("Coucou");
		}, 3000);//, 1000);
	}
*/	
	//[Interface SimObserver	
	public void simEvent(SimPilot sim_pilot, int type, ReadSimOperation rsop, long time_code) {
		String mess;
		switch(type){
		case SimPilot.SIM_INIT: 	
			rsop.addAllAgentObserver(this);
			addLog("{SIM_INIT}..."); 
			break;
		case SimPilot.SIM_START:	
			mess = "...{SIM_START ";
			long end_time = rsop.getEndTime();
			if(end_time<=0) mess+=" - no end limite - }";
			else mess+="["+UT.format(rsop.getStartTime())+" ; "+UT.format(end_time)+"] }";
			addLog(mess); 
			break;
		case SimPilot.SIM_PAUSE: addLog("{SIM_PAUSE - "+UT.format(rsop.curTime())+" }"); break;
		case SimPilot.SIM_RESUME: addLog("{SIM_RESUME}"); break;
		case SimPilot.SIM_STOP: 	addLog("{SIM_STOP}"); break;
		case SimPilot.SIM_END: 	addLog("{SIM_END}"); break;
		case SimPilot.SIM_RESET: 
			txt_area.setText("");
			addLog("{SIM_RESET ok}"); 
			break;
		}
	}	
	
	public void simLog(SimPilot sim_pilot , long time_code, String mess) {
		addLog("[SimLog - "+UT.format(time_code)+"] "+mess);
	}
	//]
	
	//[Interface AgentUObserver
	public void agentTypeAdded(String name_type, int code_type) {}
	public void agentTypeSourceChanged(int code_type) {}
	public void agentCreated(int code_type, int agentId) {}
	public void agentRemoved(int agentId) {}
	public void agentStateChange(int agentId, byte old_state, byte new_state, byte ctx) {}
	public void agentRunModeChange(int agentId, byte old_run_mode, byte new_run_mode) {}
	public void agentRenamed(int agentId, String newName) {}
	public void agentRetypep(int agentId, int code_type) {}
	public void agentWaitRetype(int agentId, int code_type) {}
	public void agentLog(int agentId, String mess, long time) {
		addLog("[AgentLog # "+agentId+" - "+UT.format(time)+"] "+mess);
	}
	public void socialChange(int agentId, String name_slot, String name_space, String md5_space_password, String local_id) {} //name_space==null si plug supprimé, md5_space_password==null si aucun mot de passe, local_id==null si déterminer aléatoirement
	public void socialPlug(int agentId, String name_slot, String current_id, int ctx) {}
	public void socialUnplug(int agentId, String name_slot, int ctx) {}	
	public void physicalPlug(int agentId, String name_slot, Spot device_spot, int device_id) {}
	public void physicalChange(int agentId, String name_slot, Spot device_Spot, int device_id) {}
	public void physicalPlugRuleAdded(int agentId, String name_slot, int rule_id, int order, PhysicalPlugRule rule) {}
	public void physicalPlugRuleRemoved(int agentId, String name_slot, int rule_id) {}
	public void physicalPlugRuleMoved(int agentId, String name_slot, int rule_id, byte direction) {} //direction = PlugRule.UP ou plugRule.DOWN
	public void physicalUnplug(int agentId, String name_slot) {}	
	//]
}
