package skuad.sim.ui;

import javax.swing.*;
import skuad.sim.SimObserver;
import skuad.sim.simop.ReadSimOperation;
import skuad.sim.simop.SimPilot;

public class SimProgressBar extends JProgressBar implements SimObserver{
	
	SimPilot simpilot;
	boolean infinyte_mode;
	
	public SimProgressBar(SimPilot vsimpilot) {
		simpilot = vsimpilot;
		setMaximum(0);
		setMaximum(100);
		setStringPainted(true);
		infinyte_mode = false;
		if(simpilot!=null) simpilot.addSimObserver(this);
	}
	
	//[Interface SimObserver
	public void simEvent(SimPilot sim_pilot, int type, ReadSimOperation rsop, long time_code) {
//if(type!=SimPilot.BEGIN_CYCLE && type!=SimPilot.END_CYCLE) System.out.println(type);		
		switch(type){
		case SimPilot.SIM_START:  case SimPilot.SIM_RESUME:
			if(rsop.getEndTime()<=0) {
				infinyte_mode=true;
				setIndeterminate(true);
				setString("infinyte");
			} else setString(null);
			break;
		case SimPilot.BEGIN_CYCLE: 
			if(rsop.getEndTime()>0) {
				float duree_total = rsop.getEndTime()-rsop.getStartTime();
				float cur = rsop.curTime()-rsop.getStartTime();
			
				this.setValue((int) Math.round((cur/duree_total)*100.0));
			}
			break;
		case SimPilot.SIM_PAUSE:
			setIndeterminate(false);
			if(infinyte_mode) setValue(50);
			setString("paused");			
			break;
		case SimPilot.SIM_STOP: 
			setIndeterminate(false);
			if(infinyte_mode) setValue(100);
			setString("stopped");
			break;
		case SimPilot.SIM_END: 
			setIndeterminate(false);
			if(infinyte_mode) setValue(100);
			setString("ended");
			break;			
		case SimPilot.SIM_RESET: 
			setValue(0);
			setString(null);
			break;
		}
	}
	public void simLog(SimPilot sim_pilot , long time_code, String mess) {}
	//]

}
