package skuad.sim.ui;

import java.awt.BorderLayout;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import skuad.sim.simop.InitSimOperation;
import skuad.sim.simop.SimPilot;
import skuad.sim.simop.StartSimOperation;
import skuad.sim.venv.SpeedClock;

public class SimSpeedClock extends JPanel implements ChangeListener{
	
	JSlider speed_level;
	SimPilot simpilot;
	JLabel speed_label;
	
	SpeedClock speed_clock;
	
	public SimSpeedClock(SimPilot vsimpilot) {
		simpilot = vsimpilot;
		
		//mep
		setLayout(new BorderLayout());
		add(new JLabel(" SPEED : "), BorderLayout.WEST);
		speed_level = new JSlider(JSlider.HORIZONTAL, 10, 500, 10);
		speed_level.setMajorTickSpacing(10);
		speed_level.setMinorTickSpacing(1);
		
		speed_clock = new SpeedClock();
		simpilot.addInitializer((SimPilot sim_pilot, InitSimOperation isop, StartSimOperation ssop)->{
			ssop.addVirtualEnv(speed_clock);
		});
		
		speed_level.addChangeListener(this);
		add(speed_level, BorderLayout.CENTER);
		
		speed_label = new JLabel("000000", JLabel.CENTER);
		add(speed_label, BorderLayout.EAST);		
		setLevelSpeed(100);
	}
	
	public void unlockSpeedClock() {
		speed_clock.unlockSpeedClock();
	}
	
	public void stateChanged(ChangeEvent e) {
	    if( speed_level == e.getSource()) {
	    	int level = speed_level.getValue();	
	    	int speed = level;
	    	int d = level-100;
	    	if(level>100) {
	    		int loga=0;
	    		loga = d*d;
	    		if(level>200) loga*=5; //{ loga*=5;  System.out.println("2 -> "+(speed+loga)); } 
	    		else if(level>400) loga*=50; //{ loga*=50; System.out.println("3 -> "+(speed+loga)); } 
	    		//else System.out.println("1 -> "+(speed+loga));
	    		speed+=loga;
	    	}
			speed_label.setText(level+" ( "+speed+" % )");
	    	speed_clock.setSpeed(speed);
	    }
	}
	
	public void setLevelSpeed(int level) {
		speed_level.setValue(level);
	}
	
}