package skuad.sim.venv;

import skuad.sim.*;
import skuad.sim.simop.*;

public class Trotter implements VirtualEnv {
	
	long p_fixe;
	long v_old_tc, r_old_tc;
	
	public Trotter(long pause_fixe) { //pause fixe entre chaque cycle
		p_fixe=pause_fixe;
	}
	
	public void start(SimPilot sim_pilot, StartSimOperation ssop) {	//la simulation démarre
		if(p_fixe==0) {
			v_old_tc=ssop.curTime();
			r_old_tc=System.currentTimeMillis();
		}
	}
		//elle peut déjà l'être si l'instance VirtualEnv est créée aprés le démarrage de la simulation
	public void stop(SimPilot sim_pilot) {}	//la simulation s'arrête	
	
	//next_tc est le timecode candidat pour le prochain cycle,  <=0 si aucun et simulation infini
	//si next_tc>0 : celui sera effectif si aucun VirtaulEnv ne retourne un nouveau 0<tc<nex_tc durant ce cycle d'appel , sinon c'est le plus petit tc>0 qui sera candidat
	//si next_tc<=0 : la simulation va s'arréter sauf au moins un VirtaulEnv retourne un nouveau 0<tc<nex_tc durant ce cycle d'appel , et si c'est le cas c'est le plus petit tc>0 qui sera candidat
	public long candidateNextTime(SimPilot sim_pilot, StartSimOperation ssop, RunSimOperation rsop, long previous_tc, long next_tc) {
		if(p_fixe==0) {
//			long v_duree=next_tc-v_old_tc;
//			long r_duree=r_old_tc-System.currentTimeMillis();
			//OXO
		}
		return(0);
	}
	
	//doit retourner true si un prochain cycle de simulation (aprés cet appel sur cur_tc) est nécessité par cet environnement
	//si aucun retour true est qu'il n'y a plus d'activité pulsable la simulation va s'arréter
	//NB: si la simulation n'est pas infini et que cur_tc>endSim la simulation va s'arréter même si true est renvoyé  
	public boolean initializeNextTime(SimPilot sim_pilot, StartSimOperation ssop, RunSimOperation rsop, long previous_tc, long cur_tc) {
		if(p_fixe>0)  try{ Thread.sleep(p_fixe); } catch(Exception e) {}
		else {
			//OXO
		}
		return(false);
	}
	
	
}