package skuad.ubiquity.implementation;

import skuad.ubiquity.space.*;
import skuad.ubiquity.space.activity.WActivity;
import skuad.ubiquity.space.alias.WAlias;
import skuad.ubiquity.space.mailbox.MailBox;
import skuad.ubiquity.space.skill.WSkill;
import skuad.ubiquity.space.state.WState;

public class ImplAvatar implements Avatar {

	LocalParticipant thisParticipant; 	//participant lié à cet avatar
	ImplMailBox mailbox;				//mailbox de l'interacteur
	
	protected ImplAvatar(LocalParticipant vparticipant){
		thisParticipant=vparticipant;
		mailbox=null;
	}
	
	//[Interface Interactor
	public Space getSpace() { return(thisParticipant.getSpace()); }; //null si le space est protégé par un mot de passe, il faut alors utilisé getSpace(String)
	public Space getSpace(String password){ return(thisParticipant.getSpace(password)); }; 
	
	public Participant participant(){
		return(thisParticipant);
	}
	
	public boolean exist(){ return(thisParticipant.exist()); }
	
	public byte remove(){
		return(thisParticipant.node.internalDeleteParticipant(thisParticipant, true)); 
	}

	public MailBox mailBox(){
		if(mailbox==null) mailbox=new ImplMailBox(thisParticipant);
		return(mailbox);
	}
	public WAlias alias(){
		return(thisParticipant.getWAlias());
	}	
	public WState state(){
		return(thisParticipant.getWState());
	}
	public WSkill skill(){
		return(thisParticipant.getWSkill());
	}
	public WActivity activity(){
		return(thisParticipant.getWActivity());
	}
	//]
}