package skuad.ubiquity.implementation;

import skuad.ubiquity.space.*;
import skuad.ubiquity.space.mailbox.*;
import skuad.util.value.Value;
import skuad.ubiquity.Ubiquity;

public class ImplMessage implements Message {
	
	Value value;
	ImplParticipant sender;
	String context;
	String idreport;
	LocalParticipant receiver;
	byte state; //0 -> not delivred, 1-> delivred, 2 -> consumed
	
	protected ImplMessage(LocalParticipant vreceiver, ImplParticipant vsender, String skill_context, Value vvalue, String vidreport){
		receiver=vreceiver;
		sender=vsender;
		value=vvalue.toConstant();
		context=skill_context;
		idreport=vidreport;
		state=0;
	}
	
	//[Interface Message
	public Participant sender(){ return(sender); }
	public String context(){ return(context); }
	public Value value(){ return(value);}
	public boolean consume(boolean performed){ //retire le message de la boite au lettre dans laquelle il se trouve	
		if(state==1){
			state=2;
			receiver.eraseMessage(this);//On supprime l'élément de la boite au lettre
			if(idreport!=null && idreport.length()>0) {//Notification de la consumation du message
//System.out.println("send report "+idreport);	
				receiver.node.space.notifySendingReport(sender, receiver, idreport, (performed? Ubiquity.PERFORMED:Ubiquity.IGNORED));
			}
			return(true);
		}
		return(false);
	}
	//]
	
	//[Méthode pour ImplSpace
	protected byte deliver(){
		if(state==0){
			state=1;
			if(receiver==null || !receiver.exist()){
				if(idreport!=null && idreport.length()>0) {//Notification de la livraison du message
					receiver.node.space.notifySendingReport(sender, receiver, idreport, Ubiquity.TARGET_NOT_EXIST);
				}
				return(Ubiquity.NOT_EXIST);
			}
			receiver.deliverMessage(this);
			
			if(idreport!=null && idreport.length()>0) {//Notification de la livraison du message
				receiver.node.space.notifySendingReport(sender, receiver, idreport, Ubiquity.DELIVRED);
			}
		}
		return(Ubiquity.OK);
	}
	//]
}