package skuad.ubiquity.implementation;

import skuad.hubudp.*;
import skuad.util.databytes.*;
import skuad.util.value.Value;
import skuad.SKUAD;

public class LocalNode extends Node {
	
	private Spot localspot;
	
	protected LocalNode(Hub hub, ImplSpace vspace, String id_space){
		super(vspace, id_space);
		
		hub.whenReady((LocalSpot lspot) -> localspot=lspot);
	}
	
	protected LocalNode(Spot spot, ImplSpace vspace, String id_space){
		super(vspace, id_space);
		localspot=spot;
	}
	
	//[Complément à l'interface Spot
	public String getId(){ return(localspot!=null ? localspot.getIdGlobal() : null); }
	public boolean isUp(){ return(true); }	
	public Spot spot(){ return(localspot); } 
	public boolean isLocal(){ return(true); }
	//]
			
	//[Pour UHost
	protected synchronized void sendFullSpotState(Spot target){ //[FULL_SPOT_STATE] (string: idSpace_emetteur) (int: nb_lparticipant_vg) { etat_complet_de_chaque_lparticipant_vg }
		DataWriter mess = DataBytes.writer();
		mess.b(Protocole.FULL_NODE_STATE).s(space.spaceid);
		if(allParticipants!=null){
			mess.i(allParticipants.size());
//System.out.println("-- sendFullSpotState with "+allParticipants.size()+" participant(s) sended to "+target.getIdTarget());			
			for(ImplParticipant participant: allParticipants.values()) participant.writeCompleteState(mess); 
		} else {
//System.out.println("-- sendFullSpotState with no participant sended to "+target.getIdTarget());			
			mess.i(0); //aucun agent global sur ce spot
		}
		
		target.send(SKUAD.UBIQUITY, mess.flushReader());
	}
	//]
	
	protected synchronized void internalReceiveMessage(ImplParticipant sender, String id_target, String context, Value mess, String id_report){
		LocalParticipant receiver = (LocalParticipant) getParticipant(id_target);		
		ImplMessage imess = new ImplMessage(receiver, sender,  context, mess, id_report);
		imess.deliver();
	}
	
	protected synchronized void internalSendingReport(String sender_id, ImplParticipant receiver, String id_report, int code){
		LocalParticipant sender = (LocalParticipant) getParticipant(sender_id);	
		if(sender!=null) sender.notifySendingReport(receiver, id_report, (byte) code);
	}
	
}