package skuad.ubiquity.implementation;

import skuad.ubiquity.space.*;
import skuad.ubiquity.space.activity.WActivity;
import skuad.ubiquity.space.mailbox.*;

public class LocalParticipant extends ImplParticipant {

	ImplAvatar avatar;
	
	protected LocalParticipant(String lid, Node v_node){
		super(lid, v_node);
		avatar=new ImplAvatar(this);
	}
	
	protected boolean remove(){
		if(super.remove()){
			if(activity!=null) activity.cancelAll(); //on annule toutes les activités de l'agent
			return(true);
		}
		return(false); //agent déjà détruit !
	}	
	
	protected WActivity getWActivity(){
		if(activity==null) activity=new Activity(this, avatar);
		return(activity); 
	}	
	
	private ImplMailBox implMailBox(){return((ImplMailBox)(avatar.mailBox()));}
	
	//[Méthode pour ImplSpace
	protected ImplAvatar getAvatar(){ return(avatar); }
	protected void deliverMessage(Message mess){ implMailBox().deliverMessage(mess); }
	protected void eraseMessage(Message mess){ implMailBox().eraseMessage(mess); }
	protected void notifySendingReport(Participant receiver, String idReport, byte code){ 
		if(exist()) implMailBox().notifySendingReport(avatar, receiver, idReport, code);
	}
	//]
}