/**
	Protocole Ubiquity :
	
	NB : 
		- uhote == hote ubiquity
		- l'usage du symbole # est interdit dans le nom d'un space
		- idSpace : pour les spaces sans mots de passe = NomDuSpace, et NomDuSpace#md5(password_md5key)
		- spot = c'est un couple (Space, host)
		
	-> chaque fois qu'un uhote détecte l'up d'un autre uhote il lui envoie la commande [GET_LIST_SPACES] pour lui 
	demander la liste des spaces auquel il est connecté. En réponse il recevra un message [LIST_SPACES].
	NB: dès la détection de l'uhote, l'instance ConnectedHost qui lui correspondant est instancié
	
	-> quand un uhote se connecte à un space, il le signale à chaque uhote en envoyant la commande [ADD_SPACE]
	
	-> quand un uhote apprend qu'un autre uhote est connecté à l'un des spaces auquel il :
			
	 	
	 est lui même connecté il lui envoie
	la commande [FULL_NODE_STATE] afin de lui indiquer sa composition locale dans ce space.
	NB: la réception d'un [FULL_NODE_STATE] équivaut aussi à recevoir un [ADD_SPACE] (même signification)
	NB: - c'est a l'envoie de [FULL_NODE_STATE] que le descripteur DistantSpot est instancié localement (s'il ne l'est pas encore)
		- c'est à la réception de [FULL_NODE_STATE] que le descripteur DistantSpot passe à l'état initialized (il est aussi créé s'il ne l'est pas encore)
		
	Sigle :
		- lparticipant : un particpant local
*/

package skuad.ubiquity.implementation;

public class Protocole {
		//Paramétrage
	public final static byte MAX_RETRY_APPLY_ACTION=10; 		//nombre d'essais maximum d'application d'une action sur un spot 
	public final static int  RETRY_APPLY_ACTION_DELAY=300;		//durée en ms entre 2 tentative d'application des actions sur un spot
	
		//Commandes générales (20-30)
	public final static byte GET_LIST_SPACES=22; 	//[GET_LIST_SPACES] 
    public final static byte LIST_SPACES=23;		//[LIST_SPACES] (int : nb_space ) {pour chaque space: (string: idSpace_emetteur) }
    
    public final static byte ADD_SPACE=24;				//[ADD_SPACE] (string: idSpace_emetteur) 
    public final static byte GET_FULL_NODE_STATE=60;	//[GET_FULL_NODE_STATE]	(string: id_space) --> demande l'envoie de [FULL_NODE_STATE]
    public final static byte FULL_NODE_STATE=25;		//[FULL_NODE_STATE] (string: idSpace_emetteur) (int: nb_lparticipant) { etat_complet_de_chaque_lparticipant } 
    														// { etat_complet_d1_lparticipant } = : (string: localId) (int: version) {desc_lparticipant}
    														// {desc_lparticipant} = [(int: nb_activity) {valeur des activity} [(int: nb_alias) {valeur des alias}  (int: nb_skill) {valeur des skill}  (int: nb_state) {valeur des state}
    
    public final static byte GET_PARTCIPANT_STATE=26; 	//[GET_PARTCIPANT_STATE] (string: idSpace_receveur ) (string: localId)
    public final static byte FULL_PARTCIPANT_STATE=27;	//[FULL_PARTCIPANT_STATE] (string: idSpace_emetteur) (string: localId) (int: version) {desc_lparticipant}  [FULL_PARTCIPANT_STATE] (string: idSpace_emetteur) (string: localId) (int: version) {desc_lparticipant}, version ==-1 si le participant n'existe pas
    													// {desc_lparticipant} = [(int: nb_activity) {valeur des activity} [(int: nb_alias) {valeur des alias}  (int: nb_skill) {valeur des skill}  (int: nb_state) {valeur des state}
    
    	//Commande de Spot (30-40)
    public final static byte POST_MESSAGE=32;		//POST_MESSAGE](string: idSpaceSite_receveur)(string: id_sender)(string: id_target)(string: skill_context)(value: mess)(string: idreport)  ->idreport=="" si pas de report
    public final static byte SENDING_REPORT=33;		//[SENDING_REPORT] (string: idSpaceSite_receveur)(string: id_sender) (string: id_target)(string: id_report)[code_report]

    	//Commandes d'évènement dans le Space (40-60)   
    public final static byte NOTIFY_ADD_PARTICIPANT=40;	//[NOTIFY_ADD_PARTICIPANT] (string: idSpaceSite_emetteur) (string : local_participant_id)
    public final static byte NOTIFY_REMOVE_PARTICIPANT=41;	//[NOTIFY_REMOVE_PARTICIPANT] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version)
    public final static byte NOTIFY_ADD_SKILL=42; 		//[NOTIFY_ADD_SKILL] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameSkill)
    public final static byte NOTIFY_REMOVE_SKILL=43; 	//[NOTIFY_REMOVE_SKILL] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameSkill)
    public final static byte NOTIFY_ALIAS_PRIORITY=44; 	//[NOTIFY_ALIAS_PRIORITY]  (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameAlias) (int: newPriority)
    public final static byte NOTIFY_REMOVE_ALIAS=45; 	//[NOTIFY_REMOVE_ALIAS]  (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameAlias)
    public final static byte NOTIFY_STATE_CHANGE=46; 	//[NOTIFY_STATE_CHANGE] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameField) (value: newValue)
    public final static byte NOTIFY_ADD_ACTIVITY=47; 	//[NOTIFY_ADD_ACTIVITY] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameActivity)
    public final static byte NOTIFY_REMOVE_ACTIVITY=48; //[NOTIFY_REMOVE_ACTIVITY] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameActivity)
    public final static byte NOTIFY_ACTIVITY_CHANGE_MODE=49; 		//[NOTIFY_ACTIVITY_CHANGE_MODE] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameActivity) [newMode]
    public final static byte NOTIFY_ACTIVITY_CHANGE_STATUS=50;  	//[NOTIFY_ACTIVITY_CHANGE_STATUS] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameActivity) [newStatus]
    public final static byte NOTIFY_ACTIVITY_CHANGE_PROGRESS=51; 	//[NOTIFY_ACTIVITY_CHANGE_PROGRESS] (string: idSpaceSite_emetteur) (string : local_participant_id) (int : version) (string: nameActivity) (int: currentStep) (int: maxStep)   
    //]
}
