package skuad.ubiquity.space.mailbox;

import skuad.ubiquity.space.*;
import skuad.util.value.Value;

public interface SendReportListener {

	/**
	 * Notification de la transmission d'un message.<br/>
	 * <br/>
	 * Quand un agent envoie un message il peut indiquer vouloir être informé du bilan de transmission de son envoi. Pour cela, il faut utiliser les méthodes 
	 * d'envoi {@link Ubiquity.agent.Avatar#send(RIdentity, String, Value, String)} ou {@link Ubiquity.agent.Interactor#send(RIdentity, String, Value, String)} qui 
	 * prennent en dernier argument une chaine d'identification de rapport. Suite à cette forme d'envoi, l'agent émetteur reçoit alors la notification
	 * de la transmission via cette méthode <b>sendingRepport</b>. Les arguments de cette dernière détaillent le bilan de transmission du message.<br/>
	 * <br/>
	 * Notez que pour une transmission de message ciblant un groupe d'alias (cible de la forme "*alias" avec la méthode d'envoi {@link Ubiquity.agent.Interactor#send(String, String, Value, String)}
	 * plusieurs destinataires peuvent potentiellement recevoir le message. Et dans ce cas, un déclenchement de cette méthode <b>sendingReport</b> sera effectué pour chacun d'eux.
	 * 
	 * @param hags Handle attribué à l'agent pour ses interactions dans le space.
	 * @param target Identité de l'agent à qui le message a été livré.
	 * @param code Status de la libraison. Celui-ci peut prendre les valeurs suivantes :
	 * <ul>
	 * 	<li>{@link Ubiquity.SKUAD#SENDDING} : pour indiquer que le message a été transmis avec succès</li>
	 * 	<li>{@link Ubiquity.SKUAD#PERFORMED} : pour indiquer que le message a été consumé par son destinataire avec le status traité</li>
	 * 	<li>{@link Ubiquity.SKUAD#IGNORED} : pour indiquer que le message a été consumé par son destinataire avec le status ignoré</li>
	 * 	<li>{@link Ubiquity.SKUAD#NOT_EXIST} : pour indiquer qu'aucune cible n'a pu être identifiée</li>
	 * </ul>
	 */
	public void sendingReport(Avatar hags, Participant target, String idReport, byte code);

}