/**
 Interface d'échange Device :
 	
	[MOVE][commande_move](int: value)
	[ACTION](int: actuator_id)(val: value)
	[GET_STATE]
	[GET_PARAMS]
	[GET_MOVE_CAPACITY]	
	[GET_SENSOR_PARAMS](int: sensor_id)
	[GET_ACTUATOR_PARAMS](int: actuator_id)
	[READ_SENSOR](int: sensor_id)	
	[LOG](string : texte)
 */
package skuad.uda;

public interface Device {
	
	//action
	public boolean log(String text);
	public boolean move(int cmd, int power);
	public boolean action(int actuator_id, int value);
	public boolean action(int actuator_id, float value);
	public boolean action(int actuator_id, byte[] value);
	
	//lecture
	public boolean getState(Monitor mon);
	public boolean getParams(Monitor mon);
	public boolean getMoveCapacity(Monitor mon);
	public boolean getSensorParam(Monitor mon, int sensor_id);
	public boolean getActuatorParam(Monitor mon, int actuator_id);
	public boolean readSensor(Monitor mon, int sensor_id);
	
	//écouteurs
	public boolean addListener(Monitor mon);
	public boolean removeListener(Monitor mon);
}