/**
 Interface d'achange Monitor :
 
[STATE][ready][config_changed]
[PARAMS](string : name)(int : type_device)(int: nb_sensor)(int: nb_actuator)[can_log]
[MOVE_CAPACITY][movement_type](int: power_min)(int: power_moy)(int: power_max)
[SENSOR_PARAMS](int : sensor_id)(string : name)(int : sensor_type)[type_value][observable]
[ACTUATOR_PARAMS](int : actuator_id)(string : name)(int : actuator_type)[type_value]
[SENSOR](int: sensor_id)(val: value)
[LOG](string : texte)
[MOVED2D](float: dx)(float: dy)(float: da)
[MOVED3D](float: dx)(float: dy)(float: dz)(float: ax)(float: ay)(float: az)

 */
package skuad.uda;

public interface Monitor {
	
		//Réponse aux requêtes
	public void params(Device dev, String name, int type_device, int nb_sensor, int nb_actuator, boolean can_log);
	public void moveCapacity(Device dev, int movement_type, int power_min, int power_moy, int power_max);
	public void sensorParam(Device dev, int sensor_id, String name, int type_sensor, int type_value, boolean observable); //nb : type_value sur 1 octet 
	public void actuatorParam(Device dev, int actuator_id, String name, int type_actuator, int type_value);	//nb : type_value sur 1 octet
	//+(déjà dans la partie Ecoute ci-dessous) public void state(Device dev, boolean ready, boolean config_changed);
	//+(déjà dans la partie Ecoute ci-dessous) public void sensorValue(...);
	
		//Ecoute
	public void state(Device dev, boolean ready, boolean config_changed);
	public void sensorValue(Device dev, int sensor_id, int value); 
	public void sensorValue(Device dev, int sensor_id, float value);
	public void sensorValue(Device dev, int sensor_id, byte[] value);
	public void moved2D(Device dev, float dx, float dy, float da);
	public void moved3D(Device dev, float dx, float dy, float dz, float ax, float ay, float az);
	public void log(Device dev, String text);

}