package skuad.uda.device;

import skuad.uda.*;

public class LogDevice extends BaseDevice {

	public LogDevice(String vname, int vtype_device, boolean vcan_log){
		super(vname, vtype_device, vcan_log);
		this.ready(true);
	}
	public void setMoveCapacity(int vmovement_type, int vpower_min, int vpower_moy, int vpower_max){ //pour la rendre publique
		super.setMoveCapacity(vmovement_type, vpower_min, vpower_moy, vpower_max);
	}
	
	public boolean log(String text){
		System.out.println("LD["+name+"] Log : "+text);
		return(true);
	}
	public boolean move(int cmd, int power){
		System.out.println("LD["+name+"] Move : "+UDA.labelMove(cmd)+" // power : "+power);
		return(true);
	}
	public boolean action(int actuator_id, int value){
		String actuator_label = "-unknow-";
		SADescriptor desc = (actuators==null || actuator_id>=actuators.size() ? null : actuators.get(actuator_id));
		if(desc!=null) actuator_label=desc.name;
		
		System.out.println("LD["+name+"] Action on actuator#"+actuator_label+"# (id="+actuator_id+"): "+value+" (int)");
		return(true);
	}
	public boolean action(int actuator_id, float value){
		String actuator_label = "-unknow-";
		SADescriptor desc = (actuators==null || actuator_id>=actuators.size() ? null : actuators.get(actuator_id));
		if(desc!=null) actuator_label=desc.name;
		
		System.out.println("LD["+name+"] Action on actuator#"+actuator_label+"# (id="+actuator_id+"): "+value+" (float)");
		return(true);
	}
	public boolean action(int actuator_id, byte[] value){
		String actuator_label = "-unknow-";
		SADescriptor desc = (actuators==null || actuator_id>=actuators.size() ? null : actuators.get(actuator_id));
		if(desc!=null) actuator_label=desc.name;
		
		System.out.println("LD["+name+"] Action on actuator#"+actuator_label+"# (id="+actuator_id+"): [["+value.length+"]] (TBytes)");
		return(true);
	}
}