/**
 * Juste un sensor : le bouton
 * sensor_id == 0
 */
package skuad.uda.gui.device;

import java.awt.*;
import javax.swing.*;

import skuad.util.databytes.DataBytes;
import skuad.uda.*;
import skuad.uda.device.*;
import skuad.util.gui.*;
import java.awt.event.*;

public class DButton extends BaseDevice implements HaveGUI {

	public final static Image IMAGE_ON = ImagePanel.loadImage(DButton.class, "images/bt_on.png");
	public final static Image IMAGE_OFF = ImagePanel.loadImage(DButton.class, "images/bt_off.png");
	
	ImagePanel gui;
	int value;	//0 ou 1
	int sensor_id;
	
	public DButton(String vname){
		super(vname, UDA.BUTTON, true);
		gui=null;
		value=0;
		
		sensor_id=addSensor("button", UDA.SBUTTON, DataBytes.INT, true);	
		ready(true);
	}

	public void push(){
		value = (value == 0 ? 1 : 0 );
		if(gui!=null) gui.setImage(value==0 ?  IMAGE_OFF : IMAGE_ON);
		fireSensorValue(sensor_id, value);
	}
	
	public JComponent getGUI(){
		if(gui == null) {
			gui = new ImagePanel(value==0 ?  IMAGE_OFF : IMAGE_ON);
			gui.addMouseListener(new MouseAdapter(){
				public void mouseReleased(MouseEvent e){
					push();
				}
			});
		}
		return(gui);
	}
	
	//[Gestion du device
	public boolean readSensor(Monitor mon, int vsensor_id){ 
		if(vsensor_id!= sensor_id) return(false); 
		mon.sensorValue(this, sensor_id, value);
		return(true);
	}
	//]
	
	
	//[Test
	public static void main(String[] args){ 
		HaveGUI.FrameFor(new DButton("DButton"), "Sensor DButton", true).setSize(250,250);
	}
	//]
}