/**
 * Juste un actuator : la lumière
 * actuator_id == 0
 */
package skuad.uda.gui.device;

import javax.swing.*;

import skuad.util.databytes.DataBytes;
import skuad.uda.*;
import skuad.uda.device.*;
import java.awt.*;
import skuad.util.gui.*;

public class DLight extends BaseDevice implements HaveGUI {

	public final static Image IMAGE_ON = ImagePanel.loadImage(DLight.class, "images/light_on.png");
	public final static Image IMAGE_OFF = ImagePanel.loadImage(DLight.class, "images/light_off.png");
	
	ImagePanel gui;
	int value;	//0 ou 1
	int actuator_id;
	
	public DLight(String vname){
		super(vname, UDA.LIGHT, true);
		gui=null;
		value=0;
		
		actuator_id=addActuator("light", UDA.ALIGHT, DataBytes.INT);	
		ready(true);
	}

	public JComponent getGUI(){
		if(gui == null) gui = new ImagePanel(value==0 ?  IMAGE_OFF : IMAGE_ON);
		return(gui);
	}
	
	//[Gestion du device
	public boolean action(int vactuator_id, float new_value){ 
		if(vactuator_id != actuator_id) return(false);
		if(new_value==0){
			if(value==1){
				value=0;
				if(gui!=null) gui.setImage(IMAGE_OFF);
			}
		} else if(value==0){
			value=1;
			if(gui!=null) gui.setImage(IMAGE_ON);
		}
		return(true);
	}
	//]
	
	//[Test
	public static void main(String[] args){ 
		HaveGUI.FrameFor(new DLight("DLight"), "Actuator ALight", true).setSize(250,250);
	}
	//]
}