package skuad.uda.gui.net;

import java.awt.BorderLayout;
import java.awt.Container;
import javax.swing.*;
import skuad.uda.*;
import skuad.util.gui.*;
import skuad.uda.gui.*;
import skuad.uda.net.*;
import skuad.uda.monitor.*;

@SuppressWarnings("serial")
public class ConnectibleGUIFrame extends JFrame /*implements ConnectionListener*/ {
	
	
	public ConnectibleGUIFrame(String title, Connectable conn, HaveGUI have_gui, boolean exit_on_close){
		super(title);
		setLocation(100,100); setResizable(false);
		if(exit_on_close) setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		Container pane = getContentPane();
		pane.setLayout(new BorderLayout());
		
		ConnectionPane connection_pane=new ConnectionPane(conn);
		pane.add(BorderLayout.NORTH, connection_pane);
		connection_pane.showBorder(true);
			
		pane.add(BorderLayout.CENTER,  have_gui.getGUI());
		
		pack();
		setVisible(true);
	}
	
	public ConnectibleGUIFrame(String title, Server serv, HaveGUI have_gui, boolean exit_on_close){
		super(title);
		setLocation(100,100); setResizable(false);
		if(exit_on_close) setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		Container pane = getContentPane();
		pane.setLayout(new BorderLayout());
		
		ServerPane server_pane=new ServerPane(serv);
		pane.add(BorderLayout.NORTH, server_pane);
		server_pane.showBorder(true);
		
		
		pane.add(BorderLayout.CENTER, have_gui.getGUI());
		
		pack();
		setVisible(true);
	}	
	
/*	//[interface ConnectionListener
	public void newConnection(String label, String ip, int port){
		have_gui.refresh();
		gui.setEnabled(true);
	}
	public void lostConnection(String label, String ip, int port){	gui.setEnabled(!label.equals("to server") && !label.equals("server")); }
	
	public void errorConnection(String mess){}
	public void warningConnection(String mess){}
	//]
*/	
	//[Test
	public static void main(String[] args){
		TcpClientDevice conn = new TcpClientDevice();
		Monitor mon = new LogMonitor("Client Side Monitor");
		conn.addListener(mon);
		conn.enableAutoRepeatMove(600); //commande move répétée toutes les 600ms
		new ConnectibleGUIFrame("Test CCF", conn, new ControlPane(conn), true);
	}
	//]
}