package skuad.uda.implementation.udaudp;

import skuad.hubudp.Spot;
import skuad.util.databytes.DataBytes;
import skuad.util.databytes.DataWriter;
import skuad.SKUAD;
import skuad.uda.Device;
import skuad.uda.Monitor;
import skuad.uda.UDA;

public class FromDevice implements Monitor { //monitor pour les demandes de lecture ponctuel déclenché à distance et la générationd des messages FROM_DEVICE
	UdaUdpManager manager;
	Spot spot;
	int did, rid;
	
	public FromDevice(UdaUdpManager vmanager, Spot t, int device_id, int response_id){ 
		manager = vmanager;
		spot = t; did = device_id; rid=response_id;
	}
	
		//Réponse aux requêtes
	public void params(Device dev, String name, int type_device, int nb_sensor, int nb_actuator, boolean can_log){
		 if(spot.isUp()){
			 DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			 UDA.encodeParams(wcmd, name, type_device, nb_sensor, nb_actuator, can_log);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());
		 }
	}	
	public void moveCapacity(Device dev, int movement_type, int power_min, int power_moy, int power_max){
		if(spot.isUp()) {
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeMoveCapacity(wcmd, movement_type, power_min, power_moy, power_max);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());
		}
	}
	public void sensorParam(Device dev, int sensor_id, String name, int type_sensor, int type_value, boolean observable){ //nb : type_value sur 1 octet
		if(spot.isUp()) {
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeSensorParam(wcmd, sensor_id, name, type_sensor, type_value, observable);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());
		}		
	}
	public void actuatorParam(Device dev, int actuator_id, String name, int type_actuator, int type_value){	//nb : type_value sur 1 octet
		if(spot.isUp()) {
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeActuatorParam(wcmd, actuator_id, name, type_actuator, type_value);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}			
	}
	//]
		//Ecoute
	public void state(Device dev, boolean ready, boolean config_changed){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeState(wcmd, ready, config_changed);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}	
	public void sensorValue(Device dev, int sensor_id, int value){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeSensorValue(wcmd, sensor_id, value);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}
	public void sensorValue(Device dev, int sensor_id, float value){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeSensorValue(wcmd, sensor_id, value);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}
	public void sensorValue(Device dev, int sensor_id, byte[] value){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeSensorValue(wcmd, sensor_id, value);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}
	public void moved2D(Device dev, float dx, float dy, float da){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeMoved2D(wcmd, dx, dy, da);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}
	public void moved3D(Device dev, float dx, float dy, float dz, float ax, float ay, float az){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeMoved3D(wcmd, dx, dy, dz, ax, ay, az);
			 if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			 else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}
	public void log(Device dev, String text){ 
		if(spot.isUp()){
			DataWriter wcmd=DataBytes.writer(); if(this.rid<=0) wcmd.b(UdaUdpManager.FROM_DEVICE).i(did);
			UDA.encodeLog(wcmd, text);
			if(this.rid>0) manager.internalResponseDevice(spot, did, rid, UDA.OK, wcmd.flushReader());
			else spot.send(SKUAD.UDA, wcmd.flushReader());	
		}
	}			
}