package skuad.uda.monitor;

import skuad.uda.*;
import java.util.*;

public class LogMonitor implements Monitor {

	String name;

	HashMap<Device, String> namedDevices;	
	
	public LogMonitor(String vname){
		name = vname;
		namedDevices=null;
	}

	//Réponse aux requêtes
	public void params(Device dev, String dname, int type_device, int nb_sensor, int nb_actuator, boolean can_log){
		System.out.println("LCR["+name+"] params : name = "+dname+" // type_device = "+type_device+" // nb_sensor = "+nb_sensor+" // nb_actuator = "+nb_actuator+ " // can_log = "+can_log);
		if(namedDevices==null) namedDevices=new HashMap<Device, String>();
		namedDevices.put(dev, dname);
	}
	public void moveCapacity(Device dev, int movement_type, int power_min, int power_moy, int power_max){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";
		
		System.out.println("LCR["+name+"][Device : "+dname+"] moveCapacity : movement_type = "+movement_type+" // power_min = "+power_min+" // power_moy = "+power_moy+" // power_max = "+power_max);		
	}
	public void sensorParam(Device dev, int sensor_id, String sname, int type_sensor, int type_value, boolean observable){ //nb : type_value sur 1 octet
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] sensorParam : sensor_id = "+sensor_id+" // name = "+sname+" // type_sensor = "+type_sensor+" // type_value = "+type_value+" // observable = "+observable);
	}
	public void actuatorParam(Device dev, int actuator_id, String aname, int type_actuator, int type_value){	//nb : type_value sur 1 octet
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] actuatorParam : actuator_id = "+actuator_id+" // name = "+aname+" // type_actuator = "+type_actuator+" // type_value = "+type_value);
	}
	//Ecoute
	public void state(Device dev, boolean ready, boolean config_changed){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] state : ready = "+ready+" // config_changed = "+config_changed);				
	}
	public void sensorValue(Device dev, int sensor_id, int value){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] sensorValue : sensor_id = "+sensor_id+" // value = "+value+" (int)");		
	}
	public void sensorValue(Device dev, int sensor_id, float value){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] sensorValue : sensor_id = "+sensor_id+" // value = "+value+" (float)");		
	}
	public void sensorValue(Device dev, int sensor_id, byte[] value){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] sensorValue : sensor_id = "+sensor_id+" // value = [["+value.length+"]] (TBytes)");		
	}
	public void moved2D(Device dev, float dx, float dy, float da){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"]Moved2D : dx = "+dx+" // dy = "+dy+" // da = "+da);
	}
	public void moved3D(Device dev, float dx, float dy, float dz, float ax, float ay, float az){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] Moved3D : dx = "+dx+" // dy = "+dy+" // dz = "+dz+" // ax = "+ax+" // ay = "+ay+" // az = "+az);
	}
	public void log(Device dev, String text){
		String dname=null;
		if(namedDevices!=null) dname=namedDevices.get(dev);
		if(dname==null) dname="-unknow-";		
		System.out.println("LCR["+name+"][Device : "+dname+"] Log : "+text);
	}
}