package skuad.uda.tools;

import skuad.uda.*;
import java.util.*;
import skuad.uda.monitor.*;

public class Coupler extends MinimalMonitor {

	//[Classe Coupler
	//Dev1(sensor : Integer) --> Dev2(actuator : Vector[Integer])
	private static HashMap<Device, Coupler> coupled=new HashMap<Device, Coupler>();  //clé Dev2
	
	public static void plug(Device source, int sensor_id, Device target, int actuator_id){
		Coupler coupler = coupled.get(target);
		if(coupler==null){
			coupler = new Coupler(target);
			coupled.put(target, coupler);
		}
		coupler.plug(source, sensor_id, actuator_id);
	}
	
	public static void unplug(Device source, int sensor_id, Device target, int actuator_id){
		Coupler coupler = coupled.get(target);
		if(coupler!=null) coupler.unplug(source, sensor_id, actuator_id);
	}
	//]
	
	//[Instance Coupler
	HashMap<Device, Vector<Integer>> coupling;
	Device target;
	
	public Coupler(Device vtarget){
		target = vtarget;
		coupling = new HashMap<Device, Vector<Integer>>();
	}
	public void plug(Device source, int sensor_id, int actuator_id ){
		Vector<Integer> plugged = coupling.get(source);
		if(plugged==null){
			plugged = new Vector<Integer>();
			coupling.put(source, plugged);
			source.addListener(this);
		}
		while(sensor_id>=plugged.size()) plugged.add(null);
		plugged.set(sensor_id, Integer.valueOf(actuator_id));
	}
	
	public void unplug(Device source, int sensor_id, int actuator_id ){
		Vector<Integer> plugged = coupling.get(source);
		if(plugged!=null && plugged.size()>sensor_id) plugged.set(sensor_id, null);
	}
	
	public void sensorValue(Device dev, int sensor_id, int value){
		Vector<Integer> plugged = coupling.get(dev);
		if(plugged!=null && sensor_id<plugged.size()){
			Integer actuator_id = plugged.get(sensor_id);
			if(actuator_id!=null) target.action(actuator_id.intValue(), value);
		}
	}
	public void sensorValue(Device dev, int sensor_id, float value){
		Vector<Integer> plugged = coupling.get(dev);
		if(plugged!=null && sensor_id<plugged.size()){
			Integer actuator_id = plugged.get(sensor_id);
			if(actuator_id!=null) target.action(actuator_id.intValue(), value);
		}
	}
	public void sensorValue(Device dev, int sensor_id, byte[] value){
		Vector<Integer> plugged = coupling.get(dev);
		if(plugged!=null && sensor_id<plugged.size()){
			Integer actuator_id = plugged.get(sensor_id);
			if(actuator_id!=null) target.action(actuator_id.intValue(), value);
		}
	}
	//]
}