package skuad.util.base;
import java.util.Iterator;

public class ConstantIterable<E> implements Iterable<E>{
	
	Iterable<E> theIterable;
	
	public ConstantIterable(Iterable<E> viterable){
		theIterable = viterable;
	}
	
	public Iterator<E> iterator(){
		return(new ReadOnlyIterator<E>(theIterable.iterator()));
	}
}

class ReadOnlyIterator<E> implements Iterator<E> {

    private Iterator<E> kernel;

    public ReadOnlyIterator(Iterator<E> it){ kernel = it; }
    public boolean hasNext(){ return(kernel.hasNext()); }
    public E next(){ return(kernel.next()); }

    public void remove() {
        throw(new UnsupportedOperationException());
    }
}