package skuad.util.base;

import java.io.*;
import java.net.URL;

public class FResource {
	
	File file;
	URL url;
	String error;
	
	//[Constructeurs
	public FResource(String path) {
		fromFile(new File(path));
	}
	public FResource(String path_dir, String path_file) {
		String path=path_dir+(path_dir.endsWith("/") ? "" : "/")+(path_file.startsWith("/") ? path_file.substring(1) : path_file);
		fromFile(new File(path));
	}
	public FResource(File vfile) {
		fromFile(vfile);
	}	
	private void fromFile(File vfile) {
		file = vfile;
		url=null;
		error=null;
	}
	public FResource(Class<?> classOwner, String path_ressource) {
		url = classOwner.getResource(path_ressource);
		file=null;
		error=null;
	}
	//]
	
	public boolean haveError() { return(error!=null); }
	public String getError() { return(error); }
	
	public URL getURL() {
		if(url==null && file!=null) {
			try {
				url = file.toURI().toURL();
			}catch(Exception e) {
				error = e.getMessage();
				url=null;
			}
		}
		return(url);
	}
	
	public InputStream getInputStream() {
		try{
			if(file!=null) return(new FileInputStream(file));
			else if(url!=null) return(url.openStream());
		}catch(Exception e) {
			error = e.getMessage();
		}
		return(null);
	}
}