/**
	Interface de lecture des données encodé dans le format DataBytes
 */
package skuad.util.databytes;

import java.io.OutputStream;

public interface DataReader extends IReader {	
	
	//Gestion de l'instance
	public void reset();			//réinitialise le pointeur de lecture
	public void split(int start);	//supprime le tronçons [0;start[ de l'espace de lecture, et réinitialise le pointeur de lecture sur cette position
	public boolean dispose();		//verouille l'instance (plus aucune action possible) et libère les ressources
	public DataReader clone();		//fournit un clone de lecture avec un pointeur de lecture réinitialisé
	public DataReader cloneRest();	//fournit un clone de lecture sur la portion restant à lire
	public DataReader splitClone(int pos_start); //fournit un clone de lecture sur la portion [pos_start; end[
	
	
	//Méthodes de lecture spécifie DataReader
	public int getByte(int pos);				
	public int curPos();			//retourne la position de lecture courante
	public boolean toPos(int pos);	//repositionne le curseur de lecture sur la position indiqué
	public int size();				//taille total des données disponible
	public int writeToStream(OutputStream out, int length); //transmission de length octets
	
	//+ les méthodes de l'interface IReader
}
