package skuad.util.gui;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;

@SuppressWarnings("serial")
public class ImagePanel extends JPanel {

	Image img;
	int img_w, img_h;

	public ImagePanel(){
		img=null;
		setLayout(null);
	}
	public ImagePanel(Object owner, String img_ress) {
		setImage(loadImage(owner.getClass(), img_ress));
		setLayout(null);
	}
	public ImagePanel(Image img) {
		setImage(img);
		setLayout(null);
	}
	public void setImage(Image vimg){
	    img = vimg;
	    img_w = img.getWidth(null);
	    img_h = img.getHeight(null);
		Dimension size = new Dimension(img_w, img_h);
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		repaint();
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if(img!=null) {
			int x = (this.getWidth()-img_w) / 2;
			int y = (this.getHeight()-img_h) / 2;
			g.drawImage(img, x, y, null);
		}
	}	 
	
	//Fonction utile
	public static Icon loadIcon(Object owner, String pfile){
		try {
			return(new ImageIcon(ImageIO.read(owner.getClass().getResource(pfile))));
		} catch(Exception e){}
		return(null);
	}
	public static Image loadImage(@SuppressWarnings("rawtypes") Class owner, String pfile){
		try {
			return(new ImageIcon(ImageIO.read(owner.getResource(pfile))).getImage());
		} catch(Exception e){}
		return(null);
	}
}