package skuad.util.thread;

/**
 * Interface des traitements réccurent.<br/>
 * <br/>
 * Un waiter est un traitements à déclencher périodiquement toutes les {@link utility.thread.ThreadStack#WAITERS_FREQUENCY} millisecondes (par défaut 5 secondes).<br/>
 * Pour cela, l'instance doit être enregistrer via la méthode : {@link utility.thread.ThreadStack#addWaiter(Waiter)}.<br/>
 * <br/>
 * Cette focntionnalité est notamment utilisée par les classes qui disposent d'une chache qu'il faut périodiquement vidanger.<br/>
 */
public interface Waiter {
	
	/**
	 * Déclenchement du code du waiter.<br/>
	 * <br/>
	 * L'implémentation de cette méthode définie le traitement qui sera réalisé par le waiter à chacune de ses activations.<br/>
	 * 
	 * @param cur_time Timecode courant (temps UNIX correspondant à l'instant d'invocation de la méthode.
	 */
	public void run(long cur_time);
	
}