/**
 * UT : time UTilities
 * 
 * Classe exposant des fonctions utilitaire en rapport au temps et son format numérique unix (entier long).
 */
package skuad.util.time;

import java.text.*;
import java.util.*;

public class UT {
	
	//Les contantes 
	public static long PING = 40; //ping standard (40 ms)
	public static long HOUR = 1000*60*60;
	public static long DAY = HOUR*24;
	public static long NO_END = -1;
	public static SimpleDateFormat date_formator = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
	
	public static long realCurTime() { return(System.currentTimeMillis()); }
	
	public static long day(int n) { return(n * DAY); }
	public static long hour(int n) { return(n * HOUR); }
	
	public static long timeLeft(long time, String h_time) { //retourne le temps restant pour atteindre le prochain horaire spécifié par la chaine h_time
		//Exemple de format possible pour h_time :
		//--> "8h30" ou "8:30"  		=> horaire au format 24h
		//--> "8h30 am" ou "4:20 pm"	=> horaire au format 12h
		boolean plus12h=false;
		if(h_time!=null) {
			h_time = h_time.trim().toLowerCase();
			if(h_time.endsWith("am")) h_time.substring(0, h_time.length()-2).trim();
			else if(h_time.endsWith("pm")) {
				plus12h=true;
				h_time.substring(0, h_time.length()-2).trim();
			}
			int sep = h_time.indexOf('h');
			if(sep==-1) sep = h_time.indexOf(':');
			if(sep>0) {
				String h_st = h_time.substring(0, sep);
				String m_st = h_time.substring(sep+1);
				int h_int=0, m_int =0;
				try {
					h_int = Integer.parseInt(h_st);
					m_int = Integer.parseInt(m_st);
				}catch(Exception e) {
					return(0); //erreur dans le format de h_time
				}
				if(plus12h && h_int<12) h_int+=12;
					
				synchronized(cache_date) {
					if(time!=cache_dtime) {
						cache_date.setTimeInMillis(time);
						cache_dtime = time;
					}
					Calendar target = (Calendar) cache_date.clone();
					target.set(Calendar.HOUR_OF_DAY, h_int);
					target.set(Calendar.MINUTE, m_int);
					
					if(target.before(cache_date)) target.add(Calendar.DAY_OF_MONTH, 1); //on ajoute 1jrs si l'horaire est déjà passé
					return(target.getTimeInMillis()-time);
				}
			}
		}
		return(0);
	}
	
	
	//[Buffer
	private static long cache_ftime=0; private static String cache_format=null;
	private static long cache_dtime=0; 
	private static Calendar cache_date=Calendar.getInstance();
	//]
	public synchronized static String format(long time) {
		if(cache_format==null || time!=cache_ftime) {
			cache_format=date_formator.format(new Date(time));
			cache_ftime = time;
		}
	    return(cache_format);
	}
	public static int getDay(long time) {
		synchronized(cache_date) {
			if(time!=cache_dtime) {
				cache_date.setTimeInMillis(time);
				cache_dtime = time;
			}
			return(cache_date.get(Calendar.DAY_OF_WEEK));
		}
	}
	public static boolean isWeekDays(int day) {
		return(day!=Calendar.SATURDAY && day!=Calendar.SUNDAY);
	}
	
	//[Filtres standards
	public final static TimeFilter weekDays = new TimeFilter() {
		public boolean validTime(long tc) {
			return(isWeekDays(getDay(tc)));
		}
	};
	//]
	
	//[A supprimer
	/**
	 * @deprecated remplacé par realCurTime()
	 */
	@Deprecated
	public static long now() { return(System.currentTimeMillis()); }
	//]
}