/*
 * Value de type ARRAY constante
 */
package skuad.util.value.implementation;
import java.util.Vector;

import skuad.util.value.Value;

public class CArray extends BaseValue {	
	protected Vector<Value> content;

	public CArray(){
		super(ARRAY,null);
		content=new Vector<Value>();
	}
	public CArray(String desc){
		super(ARRAY, desc);
		content=new Vector<Value>();
	}

	@SuppressWarnings("unchecked")
	public CArray(Vector<Value> v, String desc){
		super(ARRAY, desc);
		content=(Vector<Value>) v.clone();
	}

	//[Complément à BaseValue
			//[lecture de l'ARRAY
		public boolean exist(int p){ return((p>=0 && p<content.size()));}
		public int size(){ return(content.size()); }
		public Value get(int p){ 
			if(p<0 || p>=content.size()) return(UNDEFINED_VALUE); 
			else return(content.get(p)); 
		}
				//accesseur ARRAY rapide
		public String getString(int p){ return(get(p).toString()); }
		public int getInt(int p){ return(get(p).toInt()); }
		public boolean getBool(int p){ return(get(p).toBool()); }
		public float getFloat(int p){ return(get(p).toFloat()); }
		public byte[] getBytes(int p){ return(get(p).toBytes()); }
			//]	
	public Value toConstant() { return(this); }
	public String toString(){
		StringBuffer rep=new StringBuffer("[ ");

		boolean first = true;
		synchronized(content) { for(Value v : content) {
			if(first) first=false;
			else rep.append(" , ");
			rep.append(v.toString());
		} }
		rep.append(" ]");
		return(rep.toString()); 
	}	
	public boolean equals(Value v){
		if(v!=null && v.isArray() && v.size()==content.size()){
			synchronized(content) { for(int p=0; p<content.size(); p++) if(!content.get(p).equals(v.get(p))) return(false); }
			return(true);
		}
		return(false);
	}	
	//]	
}