package skuad.util.value.implementation;

import java.nio.charset.Charset;

import skuad.util.value.Value;
import skuad.util.base.*;

public class CAtome extends BaseValue {

	protected String st_val;
	protected float num_val;
	protected byte[] bytes_val;
	protected byte convert; //masque de convertion des types

	public CAtome(){
		super(UNDEFINED,null);
		convert=UNDEFINED; 
	}	
	public CAtome(String s){
		super(STRING,null);
		st_val=s; 
		convert=STRING; 
	}
	public CAtome(byte[] bs){
		super(BYTES,null);
		bytes_val=bs; 
		convert=BYTES; 
	}
	public CAtome(String s, String desc){
		super(STRING,desc);
		st_val=s; 
		convert=STRING; 
	}
	public CAtome(byte t, String s, float i, byte c, String desc){
		super(t, desc);
		st_val=s; 
		num_val=i;
		convert=c; 
	}
	
	//[Complément à BaseValue
	  //[lecture de l'atome (STRING, INT, BOOL)
		public String toString(){ convertTo(STRING); return(st_val); }
		public int toInt(){ convertTo(INT); return((int) num_val); }
		public boolean toBool(){ convertTo(BOOL); return(num_val!=0); }
		public float toFloat(){ convertTo(FLOAT); return(num_val); }
		public byte[] toBytes(){ convertTo(BYTES); return(bytes_val == null ? null : bytes_val.clone()); }
	  //]
	public Value toConstant() { return(this); }	
	public boolean equals(Value v){
		if(v!=null && v.isAtome()){
			switch(type){
			case STRING : if(st_val==null) return(v.toString()==null); else return(st_val.equals(v.toString())); 
			case INT : return(((int)num_val)==v.toFloat());
			case BOOL : return((num_val!=0 && v.toBool()) || !v.toBool());
			case FLOAT :return(num_val==v.toFloat());
			case BYTES :
				byte[] bs = v.toBytes();
				if(bytes_val==null) return(bs==null);
				if(bs!=null) {
					if(bytes_val.length==bs.length) {
						for(int i=0; i<bs.length; i++) if(bytes_val[i]!=bs[i]) return(false);
						return(true);
					}
				}
				return(false);
			case UNDEFINED : return(v.getType()==UNDEFINED);
			}
		}
		return(false);
	}
	//]	
		
	//[méthode interne
	private void convertTo(byte t){ //t != UNDEFINED et != ERROR
		if((convert & t)==0){ //convertion nécessaire
			switch(t){
			case STRING : switch(type){
				case UNDEFINED:  st_val=null; break;
				case INT:  st_val=String.valueOf((int)num_val); break;
				case BOOL: st_val=(num_val!=0?"true":"false"); break;
				case FLOAT:  st_val=String.valueOf(num_val); break;
				case BYTES:
					if(bytes_val==null)  st_val=null;
					else st_val= new String(bytes_val, Charset.forName("UTF-8"));
					break;
				default: st_val=null; //ARRAY ou HASH 
				}; break;
			case INT : switch(type){
				case UNDEFINED:  num_val=0; break;
				case STRING:  
					try{ num_val=Integer.parseInt(st_val);} 
					catch(Exception e){ num_val=ERROR;} //conversion impossible
					break;
				case BOOL: case FLOAT: break; 
				case BYTES:
					num_val=Util.bytesToInt(bytes_val, 0);
					break;
				default: num_val=0; //ARRAY ou HASH 					
				}; break;
			case FLOAT: switch(type){
				case UNDEFINED:  num_val=0; break;
				case STRING:  
					try{ num_val=Float.parseFloat(st_val);} 
					catch(Exception e){ num_val=ERROR;} //conversion impossible
					break;
				case BYTES:
					num_val=Float.intBitsToFloat(Util.bytesToInt(bytes_val, 0));
					break;
				case BOOL: case INT: break; 
				default: num_val=0; //ARRAY ou HASH 					
				}; break;				
			case BOOL : 				
				switch(type){
				case UNDEFINED:  num_val=0; break;
				case STRING:  
					num_val= ((st_val!=null && !st_val.equals("0") && !st_val.equalsIgnoreCase("false"))?1:0); 
					break;
				case BYTES:
					num_val= (bytes_val==null || (bytes_val.length==1 && bytes_val[0]==0) ? 0 : 1);
				case INT: case FLOAT: break; 
				default: num_val=0; //ARRAY ou HASH 						
				}; break;
			case BYTES :switch(type){
				case UNDEFINED:  st_val=null; break;
				case STRING : bytes_val=(st_val==null ? null : st_val.getBytes(Charset.forName("UTF-8"))); break;
				case INT:  
					bytes_val= Util.intToBytes((int) num_val, null, 0);
					break;
				case BOOL: 
					bytes_val= new byte[1];
					bytes_val[0] = (byte)(num_val!=0 ? 1 : 0);
					break;
				case FLOAT:  
					bytes_val= Util.intToBytes(Float.floatToIntBits(num_val), null, 0);
					break;
				default: st_val=null; //ARRAY ou HASH 
			}; break;
			//ARRAY ou HASH ras
			}
			convert|=t;
		}
	}
	//]
}
