/*
 * Value de type INT constante
 */
package skuad.util.value.implementation;

import skuad.util.value.Value;

public class CIntValue extends BaseValue {
	int val;
	String st_val;
	static Value littleInt[]=new Value[16]; //optimisation pour les petits entiers (0< n <16)
	
	public static Value of(int v){
		if(v>=0 && v<16){ //optimisation pour les petits entiers (0< n <16)
			Value val=null;
			synchronized(littleInt) {
				val = littleInt[v];
				if(val == null){
					val=new CIntValue(v);
					littleInt[v]=val;
				}
			}
			return(val);
		}
		return(new CIntValue(v));
	}
	
	public CIntValue(int v){ super(INT, null); val=v; st_val=null; }
	public CIntValue(int v, String desc){ super(INT, desc); val=v; st_val=null; }
	public CIntValue(String v, String desc){ 
		super(INT, desc); 
		try { val=Integer.parseInt(v); } catch(Exception e){ val=-1; } 
		st_val=null; 
	}
	
	//[Complément à BaseValue
	  //[lecture de l'atome (STRING, INT, BOOL)
		public String toString(){ if(st_val==null) st_val=String.valueOf(val); return(st_val);}
		public int toInt(){ return(val); }
		public boolean toBool(){ return(val!=0); }
		public float toFloat(){ return(val); }
	  //]
	public Value toConstant() { return(this); }	
	public boolean equals(Value v){
		return(v!=null && v.isAtome() && ((v.getType()==INT && val==v.toInt()) || val==v.toFloat()));
	}
	//]
}