/** 
   Programme de test : TcpCouplingClient
 
   Ce programme permet de tester le bon fonction du ponteur TCP, il s'utilise avec le programme test.uda.TcpCouplingServer.
   
   Pour plus de détails lancer ce programme avec l'option -h
*/
package test.uda;

import skuad.util.base.LaunchOption;
import skuad.uda.gui.device.*;
import skuad.uda.gui.net.ConnectibleGUIFrame;
import skuad.uda.net.TcpClientDevice;
import skuad.uda.tools.Coupler;

public class TcpCouplingClient {
	
	public static void main(String[] args){
		LaunchOption options = new LaunchOption(args);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme TcpCouplingClient : permet de le bon fonction du ponteur TCP.\n"
					+   " NB: ce programme s'utilise avec le programme test.uda.TcpCouplingServer.\n"
					+ 	"  Comportement du programme : \n"
					+tab+ "- un device bouton virtuel (classe uda.gui.device.DButton) est créé.\n"
					+tab+ "- ce device est ensuite couplé localement avec le ponteur TcpClientDevice (uda.net.TcpClientDevice).\n"
					+tab+ "- une interface graphique pour gérer la connexion TCP du ponteur TcpClientDevice est affichée à\n"
					+tab+ "  l'aide de la classe ConnectibleGUIFrame.\n"
						+   "\n"
					+ 	" Arguments de lancement possibles :\n"
					+tab+ "  (aucun)"
			);
		} else {
			//Le device maitre
			DButton dButton = new DButton("Le bouton");
			//Le client TCP du device slave
			TcpClientDevice tcp_device = new TcpClientDevice();
		
			//Couplage
			Coupler.plug(dButton, 0, tcp_device, 0);
		
			//Affichage de l'interface
			ConnectibleGUIFrame ccf = new ConnectibleGUIFrame("Client Master", tcp_device, dButton, true);
			ccf.setLocation(100, 200);
		}
	}
	
}