/** 
   Programme de test : TcpCouplingServer
 
   Ce programme permet de tester le bon fonction du ponteur TCP, il s'utilise avec le programme test.uda.TcpCouplingServer.
   
   Pour plus de détails lancer ce programme avec l'option -h
*/
package test.uda;

import skuad.util.base.LaunchOption;
import skuad.uda.gui.device.*;
import skuad.uda.gui.net.ConnectibleGUIFrame;
import skuad.uda.net.TcpServerDevice;

public class TcpCouplingServer {
	
	public static void main(String[] args){
		LaunchOption options = new LaunchOption(args);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme TcpCouplingServer : permet de le bon fonction du ponteur TCP.\n"
					+   " NB: ce programme s'utilise avec le programme test.uda.TcpCouplingClient.\n"
					+ 	"  Comportement du programme : \n"
					+tab+ "- un device lumière virtuel (classe uda.gui.device.DLight) est créé.\n"
					+tab+ "- ce device est ensuite couplé localement avec le ponteur TcpServerDevice (uda.net.TcpServerDevice)\n"
					+tab+ "- une interface graphique pour gérer la connexion TCP du ponteur TcpServerDevice est affichée à\n"
					+tab+ "  l'aide de la classe ConnectibleGUIFrame.\n"
						+   "\n"
					+ 	" Arguments de lancement possibles :\n"
					+tab+ "  (aucun)"
			);
		} else {
			//Le device slave
			DLight dLight = new DLight("La lumière");	
		
			//Affichage de l'interface
			ConnectibleGUIFrame ccf = new ConnectibleGUIFrame("Server slave", new TcpServerDevice(dLight), dLight, true);
			ccf.setLocation(500, 200);
		}
	}	
}