/** 
  Programme utilitaire : LinkerPortal
 
    Pour plus de détails lancer ce programme avec l'option -h
 */
package tools.hubudp;

import skuad.hubudp.*;
import skuad.util.base.LaunchOption;

public class LinkerPortal {
	
	public static void main(String[] config) {
		//Analyse des arguments de lancement
		LaunchOption options = new LaunchOption(config);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme LinkerPortal : active un portail distant (i.e. le relie au hub local). \n"
					+ 	" Arguments de lancement possibles (tous facultatifs, sauf mention contraire):\n"
					+tab+ "-portal IP PORT : IP:PORT du portail à activer [obligatoire]\n"
					+tab+ "-link_key LINK_KEY : mot de passe pour l'activiation du portail"
			);
			System.out.println(HubUdp.hubOptions(tab, false));	
		} else {
			System.out.println("[LinkerPortal] programme lancé");
					
			String ip_portal = options.val("portal", null);
			int port_portal = options.intVal("portal",1,0);
			String link_key = options.val("link_key", null);
	
			if(ip_portal==null || port_portal<=0) {
				System.out.println("Erreur: vous devez indiquer l'ip et le port du portail à activer via l'option : -portal IP PORT");
				return;
			}
		
			Hub hub = HubUdp.joinHub(options, false); //on se connecte au hub local
		
			if(hub!=null) {
				if(hub.linkPortal(ip_portal, port_portal, link_key)) System.out.println("- association du hub avec le portail : "+ip_portal+":"+port_portal+" établie !");
				else System.out.println("... impossible de s'associer au portail : "+ip_portal+":"+port_portal);
			} else System.out.println("... impossible de se connecter au hub !");
		}
	}
}