/** 
   Programme utilitaire : Portal
 
   Comportement du programme :
   - ce programme se limite à créer un portail sur le port spécifié en argument de lancement
   (ou à défaut sur le port 30000). 
   
   Pour plus de détails lancer ce programme avec l'option -h
 */
package tools.hubudp;

import skuad.hubudp.*;
import skuad.util.base.*;

public class Portal {
	
	public final static int DEFAULT_PORT = 30000;
	
	public static void main(String[] args) {		
		LaunchOption options = new LaunchOption(args);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme Portal : crée un portail de connexion. \n"
					+ 	" Arguments de lancement possibles (tous facultatifs, sauf mention contraire):\n"
					+tab+ "-port PORT : port d'écoute du portail, (30000 par défaut) \n"
					+tab+ "-link_key LINK_KEY : mot de passe pour l'activiation du portail"
			);
		} else {
			System.out.println("[Portal] programme lancé");
			int port= options.intVal("port", DEFAULT_PORT);
			String link_key = options.val("link_key", null);
		
			//Création du portail
			if(HubUdp.newPortal(port, link_key)) System.out.println("Portail créé sur le port : "+port);
			else System.out.println("** Erreur : impossible de créé portail sur le port : "+port);
		}
	}
}