/** 
   Programme de test : DButtonUDP
 
   Pour plus de détails lancer ce programme avec l'option -h
*/
package tools.uda;

import skuad.uda.net.*;
import skuad.util.gui.*;
import skuad.hubudp.*;
import skuad.util.base.LaunchOption;
import skuad.uda.gui.device.*;

public class DButtonUDP {
	
	public static void main(String[] config){
		LaunchOption options = new LaunchOption(config);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme DButtonUDP : crée un device virtuel bouton avec une interface graphique pour l'actionner.\n"
					+ 	" Arguments de lancement possible :\n"
					+tab+ "-name NAME : nom à donner au device (\"Java DButton\" par défaut)"	
			);
			System.out.println(HubUdp.hubOptions(tab, false));	
		} else {
			System.out.println("[DButtonUDP] programme lancé");
			String name = options.val("name", "Java DButton");
			DButton device =  new DButton(name);
			HaveGUI.FrameFor(device, "Sensor : "+name, true).setSize(250,250);
		
			Hub hub = HubUdp.joinHub(options, true);
			hub.whenReady((LocalSpot localspot) -> {
				UdaUdp.expose(hub, device);
			});
		}
	}	
	
}