/** 
   Programme de test : DLightUDP
 
   Pour plus de détails lancer ce programme avec l'option -h
*/
package tools.uda;

import skuad.uda.net.*;
import skuad.util.gui.*;
import skuad.hubudp.Hub;
import skuad.hubudp.HubUdp;
import skuad.hubudp.LocalSpot;
import skuad.util.base.LaunchOption;
import skuad.uda.gui.device.DLight;

public class DLightUDP {
	
	public static void main(String[] config){
		LaunchOption options = new LaunchOption(config);
		if(options.existField("h")) { //affichage des options de lancement
			String tab="    ";
			System.out.println(
						" Programme DLightUDP : crée un device virtuel lumière avec une interface graphique pour le visualiser.\n"
					+ 	" Arguments de lancement possible :\n"
					+tab+ "-name NAME : nom à donner au device (\"Java DLight\" par défaut)"									
			);
			System.out.println(HubUdp.hubOptions(tab, false));	
		} else {
			System.out.println("[DLightUDP] programme lancé");
			String name = options.val("name", "Java DLight");
			DLight device =  new DLight(name);
			HaveGUI.FrameFor(device, "Actuator : "+name, true).setSize(250,250);
		
			Hub hub = HubUdp.joinHub(options, true);
			hub.whenReady((LocalSpot localspot) -> {
				UdaUdp.expose(hub, device);
				System.out.println("LocalSpot global_id = "+localspot.getIdGlobal());
			});
		}
	}
}